' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Combat module (8) -------------------------------------
' ---------------------------------------------------------
' Parameters:
'   Parameter1: 0 = Enemy move
'               1 = Phasers
'               2 = Torpedoes


' Start calling Combat sub
Combat()
' Return to Main module
STOP


' - Definitions -------------------------------------------
#DEFINE CLOAK_NOTAVAILABLE 0
#DEFINE CLOAK_AVAILABLE 1
#DEFINE CLOAK_CLOAKED 2


' - Vars --------------------------------------------------
' Enemy
DIM Ene_X, Ene_Y, Ene_Spd, Ene_Type, Ene_Cloak AS Integer
DIM Ene_Shield, Ene_Damage, Ene_Phasers, Ene_Torpedoes AS UByte
DIM Ene_PhasersColdDown, Ene_TorpedoesColdDown AS UByte
DIM AttackRange, rangeX, rangeY AS Byte
DIM LogsText(3) AS String


' - Includes ----------------------------------------------
#INCLUDE <NextLibLite.bas>
#INCLUDE <Keys.bas>
#INCLUDE <Retrace.bas>
#include <Hex.bas>

#INCLUDE "Common.bas"
#INCLUDE "LCARS_Next.bas"
#INCLUDE "LCARS_Nav_Next.bas"
#INCLUDE "LCARS_Combat_Next.bas"


' - Combat ------------------------------------------------
SUB Combat()
    IF Parameter1 = 0 THEN
        Combat_MoveEnemies()
    END IF
    
    IF Status_Damage >= 100 THEN
        NextModule = MODULE_REPORT
        Parameter1 = 7 
        RETURN
    END IF

    IF Status_Condition = 2 THEN
        Combat_ShowLog()
        LCARS_Nav_DrawEnterprise()
        LCARS_Nav_DrawEnemy()
    END IF

    ' return to game after combat execution
    NextModule = MODULE_GAME
    Parameter1 = 10
    
    BankSwitch67(BANK_LCARS_FONT)
END SUB


' - Returns the ship type name ----------------------------
FUNCTION Combat_GetShipName(type AS UByte) AS String
    IF type = ENEMIES_TYPE_NONE THEN
        RETURN "ENTERPRISE"
    ELSEIF type = ENEMIES_TYPE_KLINGON THEN
        RETURN "KLINGON"
    ELSEIF type = ENEMIES_TYPE_ROMULAN THEN
        RETURN "ROMULAN"
    ELSE
        RETURN "BORG"
    END IF
END FUNCTION


SUB Combat_MoveEnemies()
    DIM n AS UByte
    
    FOR n = 0 TO ENEMIES_SECTOR_MAX
        Ene_Type = Enemies_Sector(n,ENEMIES_SECTOR_TYPE)
        IF Ene_Type <> 0 THEN
            Ene_X = Enemies_Sector(n,ENEMIES_SECTOR_X)
            Ene_Y = Enemies_Sector(n,ENEMIES_SECTOR_Y)
            Ene_Damage = Enemies_Sector(n,ENEMIES_SECTOR_DAMAGE)
            Ene_Shield = Enemies_Sector(n,ENEMIES_SECTOR_SHIELD)
            Ene_Phasers = Enemies_Sector(n,ENEMIES_SECTOR_PHASERS)
            Ene_Torpedoes = Enemies_Sector(n,ENEMIES_SECTOR_TORPEDOES)
            Ene_PhasersColdDown = Enemies_Sector(n,ENEMIES_SECTOR_PHASERS_COLDDOWN)
            Ene_TorpedoesColdDown = Enemies_Sector(n,ENEMIES_SECTOR_TORPEDOES_COLDDOWN)
            
            ' Cold downs
            IF Ene_PhasersColdDown > 0 THEN
                Ene_PhasersColdDown = Ene_PhasersColdDown - 1
                Enemies_Sector(n,ENEMIES_SECTOR_PHASERS_COLDDOWN) = Ene_PhasersColdDown
            END IF            
            IF Ene_TorpedoesColdDown > 0 THEN
                Ene_TorpedoesColdDown = Ene_TorpedoesColdDown - 1
                Enemies_Sector(n,ENEMIES_SECTOR_TORPEDOES_COLDDOWN) = Ene_TorpedoesColdDown
            END IF

            rangeX = Status_Position_Sector_X - Ene_X
            rangeY = Status_Position_Sector_Y - Ene_Y
            AttackRange = 0
            IF ABS(rangeX) <= 10 THEN
                IF ABS(rangeY) <= 10 THEN
                    AttackRange = 1
                END IF
            END IF

            ' Delete enemy from sector map
            BankSwitch67(BANK_SECTOR_MAP)
            Map_Sector(Ene_X,Ene_Y) = 0
            
            IF Ene_Type = ENEMIES_TYPE_KLINGON THEN
                ' TODO: Klingon
                Combat_MoveKlingon(n)
            ELSEIF Ene_Type = ENEMIES_TYPE_ROMULAN THEN
                ' TODO: Romulan
                Combat_MoveKlingon(n)
            ELSEIF Ene_Type = ENEMIES_TYPE_BORG THEN
                ' TODO: Borg
                Combat_MoveKlingon(n)
            END IF
            
            ' Check bounds
            IF Ene_X < 0 THEN
                Ene_X = 0
            ELSEIF Ene_X > MAP_SECTOR_MAXX THEN
                Ene_X = MAP_SECTOR_MAXX
            END IF
            IF Ene_Y < 0 THEN
                Ene_Y = 0
            ELSEIF Ene_Y > MAP_SECTOR_MAXY THEN
                Ene_Y = MAP_SECTOR_MAXY
            END IF
            
            IF Status_Damage >= 100 THEN
                RETURN
            END IF
            
            ' Put enemy on sector map
            BankSwitch67(BANK_SECTOR_MAP)
            Map_Sector(Ene_X,Ene_Y) = Ene_Type
            
            Enemies_Sector(n,ENEMIES_SECTOR_X) = Ene_X
            Enemies_Sector(n,ENEMIES_SECTOR_Y) = Ene_Y
        END IF
    NEXT n
END SUB


SUB Combat_MoveKlingon(id AS UByte)
    DIM desp AS Byte
    DIM r, limit AS UByte
    
    IF AttackRange = 0 THEN
        IF Ene_Damage < 80 THEN      
            Ene_X = Ene_X + ValueBound(rangeX,-10,10)
            Ene_Y = Ene_Y + ValueBound(rangeY,-10,10)
            IF Ene_X > MAP_SECTOR_MAXX THEN
                Ene_X = MAP_SECTOR_MAXX
            ELSEIF Ene_X < 0 THEN
                Ene_X = 0
            END IF
            IF Ene_X > MAP_SECTOR_MAXX THEN
                Ene_X = MAP_SECTOR_MAXX
            ELSEIF Ene_X < 0 THEN
                Ene_X = 0
            END IF
            RETURN
        END IF
    ELSE
        limit = Config_GameLevel * 10
        ' Fire?
        r = RND * 100
        ' Fire Torpedoes
        IF  r < limit THEN
            IF Ene_PhasersColdDown = 0 THEN
                Combat_Fire(id,1)
                Ene_PhasersColdDown = 2
                RETURN
            END IF
        ' Fire Phasers
        ELSE
            IF Ene_TorpedoesColdDown = 0 THEN
                Combat_Fire(id,2)
                Ene_TorpedoesColdDown = 4
                RETURN
            END IF
        END IF
    END IF
END SUB


FUNCTION Combat_Fire_Direction() AS UByte
    IF rangeX = 0 THEN
        IF rangeY < 0 THEN
            RETURN 1
        ELSE
            RETURN 5
        END IF
    ELSEIF rangeY = 0 THEN
        IF rangeX < 0 THEN
            RETURN 7
        ELSE
            RETURN 3
        END IF
    ELSEIF rangeX = rangeY THEN
        IF rangeX > 0 THEN
            IF rangeY < 0 THEN
                RETURN 2
            ELSE
                RETURN 4
            END IF
        ELSE
            IF rangeY < 0 THEN
                RETURN 8
            ELSE
                RETURN 6
            END IF
        END IF
    END IF
    RETURN 0
END FUNCTION


SUB Combat_Fire(id AS UByte, w AS UByte)
    DIM dir, r, pow AS Byte
    DIM txt AS String
    
    dir = Combat_Fire_Direction()
    IF dir = 0 THEN
        ' If not angle to fire, move to get angle
        IF rangeY = 0 THEN
            Ene_Y = Ene_Y + rangeY
        ELSE
            Ene_X = Ene_X + rangeX
        END IF
    END IF
    
    txt = Combat_GetShipName(Enemies_Sector(id,ENEMIES_SECTOR_TYPE))
    
    IF w = 1 THEN
        ' Torpedoes
        r = INT(RND * 80) + 1    
        pow = Config_GameLevel * r 
        Enemies_Sector(id,ENEMIES_SECTOR_TORPEDOES_COLDDOWN) = 10
        txt = txt + " FIRE TORPEDOES"
    ELSE
        ' Phasers
        r = INT(RND * 40) + 1    
        pow = Config_GameLevel * r
        Enemies_Sector(id,ENEMIES_SECTOR_PHASERS_COLDDOWN) = 5
        txt = txt + " FIRE PHASERS"
    END IF    
    Combat_AddLog(txt)
    
    IF Status_Condition = 2 THEN
        ' Damage with Shields up
        pow = Status_ShieldLevel - pow
        IF pow < 0 THEN                  
            IF Status_ShieldLevel > 0 THEN
                              '01234567890123456789
                Combat_AddLog("ALERT: SHIELDS DOWN")
            END IF
            Status_ShieldLevel = 0
            Status_Damage = Status_Damage + ABS(pow)
            Combat_AddLog("ENTERPRISE DAMAGE "+str(Status_Damage)+"%")
        ELSE
            Status_ShieldLevel = pow
            Combat_AddLog("ENTERPRISE SHIELD "+str(Status_ShieldLevel)+"%")
        END IF
    ELSE
        ' damage with shields down
        Status_Damage = Status_Damage + pow
        Combat_AddLog("ENTERPRISE DAMAGE "+str(Status_Damage)+"%")
    END IF
    
    IF Status_Damage >= 100 OR Status_Damage < 0 THEN 
        Status_Damage = 100
        RETURN
    END IF
    
    ' TODO: Destroy sistems... 

END SUB


SUB Combat_AddLog(text AS String) 
    DIM n, pos AS UByte
    DIM dir AS UInteger

    ' Copy buffer to array
    dir = @LogsBuffer
    pos = 255
    FOR n = 0 TO 3
        LogsText(n) = Buffer2Text(dir,21)
        dir = dir + 22
        IF pos = 255 THEN
            IF LEN(LogsText(n)) = 0 THEN
                pos = n
            END IF
        END IF
    NEXT n

    IF pos <> 255 THEN
        LogsText(pos) = text
    ELSE
        FOR n = 0 TO 2
            LogsText(n) = LogsText(n+1)
        NEXT n
        LogsText(3) = text
    END IF
    
    ' Save LogsText into buffer
    dir = @LogsBuffer
    FOR n = 0 TO 3
        Text2Buffer(LogsText(n),dir,21)
        dir = dir + 22
    NEXT n
END SUB


SUB Combat_ShowLog()
    DIM n AS UByte
    DIM dir AS UInteger
    
    ' Read log buffer
    dir = @LogsBuffer
    FOR n = 0 TO 3        
        LogsText(n) = Buffer2Text(dir,21)
        dir = dir + 22
    NEXT n
    
    LCARS_Combat_ShowLog()
END SUB
