' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Common module -----------------------------------------
' ---------------------------------------------------------


' - Defines -----------------------------------------------
' CommonVars start address
#DEFINE VARS_ADDR $641E

' Modules
#DEFINE MODULE_GAME 0
#DEFINE MODULE_INTRO 1
#DEFINE MODULE_STATUS 2
#DEFINE MODULE_HELP 3
#DEFINE MODULE_MAP 4
#DEFINE MODULE_DAMAGE 5
#DEFINE MODULE_NAV 6
#DEFINE MODULE_REPORT 7
#DEFINE MODULE_COMBAT 8

' Menu options
#DEFINE OPT_RED 0
#DEFINE OPT_STATUS 1
#DEFINE OPT_DAMAGE 2
#DEFINE OPT_MAP 3
#DEFINE OPT_NAV 4
#DEFINE OPT_TACTIC 5
#DEFINE OPT_OPS 6
#DEFINE OPT_CTRL 7
#DEFINE OPT_HELP 8
#DEFINE OPT_GREEN 9

' Condition (Status_Condition, Status_Shield)
#DEFINE CONDITION_GREEN 0
#DEFINE CONDITION_YELLOW 1
#DEFINE CONDITION_RED 2

' Maximun values
#DEFINE ENERGY_MAX 5000

' Map
' Maximun galaxy size, check "Map_Quadrants" variable location
' and size if changed
#DEFINE MAP_GALAXY_MAXX 9
#DEFINE MAP_GALAXY_MAXY 13
' Entire galaxy map 6x6 every sector, 10x14 sectors (5040 bytes)
#DEFINE MAP_SECTOR_MAXX 59
#DEFINE MAP_SECTOR_MAXY 59
' Objects in sector map
'  7  6  5  4  3  2  1  0
' PC PM PL PL PL SB BS RS
'                   BHOLE
' PC = Planet with Crystals (requires Sol)
' PM = Class M planet (post) (requires Sol)
' PL = Planet (no crystals, no post) (requires Sol)
' SB = StarBase
' BS = Blue Sol
' RS = Red Sol
' BS + RS = Black Hole
#DEFINE MAP_OBJECT_NONE 0
#DEFINE MAP_OBJECT_ROMULAN 1
#DEFINE MAP_OBJECT_KLINGON 2
#DEFINE MAP_OBJECT_BORG 3
#DEFINE MAP_OBJECT_STARBASE 4
#DEFINE MAP_OBJECT_STAR_RED 5
#DEFINE MAP_OBJECT_STAR_BLUE 6
#DEFINE MAP_OBJECT_PLANET_0 7
#DEFINE MAP_OBJECT_PLANET_1 8
#DEFINE MAP_OBJECT_PLANET_2 9
#DEFINE MAP_OBJECT_PLANET_M 10
#DEFINE MAP_OBJECT_PLANET_DILITRIUM 11
#DEFINE MAP_OBJECT_SUPERNOVA 255

' Zones
#DEFINE ZONE_FEDERATION 0
#DEFINE ZONE_ROMULAN 1
#DEFINE ZONE_KLINGON 2
#DEFINE ZONE_NEUTRAL 3

' Enemies
' Global max enemies (set Enemies_Galaxy address if changed)
#DEFINE ENEMIES_GALAXY_MAX 63
#DEFINE ENEMIES_GALAXY_TYPE 0
#DEFINE ENEMIES_GALAXY_X 1
#DEFINE ENEMIES_GALAXY_Y 2

' Max enemies for sector (set Enemies_Sector address if changed)
#DEFINE ENEMIES_SECTOR_MAX 3
#DEFINE ENEMIES_SECTOR_TYPE 0
#DEFINE ENEMIES_SECTOR_X 1
#DEFINE ENEMIES_SECTOR_Y 2
#DEFINE ENEMIES_SECTOR_DAMAGE 3
#DEFINE ENEMIES_SECTOR_SHIELD 4
#DEFINE ENEMIES_SECTOR_PHASERS 5
#DEFINE ENEMIES_SECTOR_TORPEDOES 6
#DEFINE ENEMIES_SECTOR_PHASERS_COLDDOWN 7
#DEFINE ENEMIES_SECTOR_TORPEDOES_COLDDOWN 8
' 0=Not cloak, 1=Can cloak, 2=cloaked
#DEFINE ENEMIES_SECTOR_CLOAK 7

' Enemy types
#DEFINE ENEMIES_TYPE_NONE 0
#DEFINE ENEMIES_TYPE_KLINGON 1
#DEFINE ENEMIES_TYPE_ROMULAN 2
#DEFINE ENEMIES_TYPE_BORG 3

' Attack ranges
#DEFINE ENEMIES_ENTERPRISE_ATTACKRANGE 6
#DEFINE ENEMIES_KLINGON_ATTACKRANGE 5
#DEFINE ENEMIES_ROMULAN_ATTACKRANGE 7
#DEFINE ENEMIES_BORG_ATTACKRANGE 5

' Memory banks for Next
#DEFINE BANK_TEMP 34
#DEFINE BANK_LCARS_FONT 36
#DEFINE BANK_LCARS_GRID 38
#DEFINE BANK_BITMAPS1 40
#DEFINE BANK_COMBAT_BACKGROUND 42
#DEFINE BANK_COMBAT_SHIPS 44
'#DEFINE BANK_COMBAT_ENEMY 46
#DEFINE BANK_TACTIC_ENTERPRISE 48
#DEFINE BANK_TACTIC_ENEMY 50
' Warp animation start
#DEFINE BANK_VIDEO_WARP 52
#DEFINE VIDEO_WARP_FRAMES 52
' Warp animation end: 106 -> 53 banks of 8Kb (424Kb)
#DEFINE BANK_VIDEO_WARPEND 106
#DEFINE BANK_SECTOR_MAP 108

' Bitmaps addresses
#DEFINE BITMAP_ADDR_DAMAGE $c000
#DEFINE BITMAP_LENGTH_DAMAGE 1625
#DEFINE BITMAP_ADDR_DATA $c659
#DEFINE BITMAP_LENGTH_DATA 696
#DEFINE BITMAP_ADDR_GEORDI $c911
#DEFINE BITMAP_LENGTH_GEORDI 710
#DEFINE BITMAP_ADDR_PICARD $cbd7
#DEFINE BITMAP_LENGTH_PICARD 920
#DEFINE BITMAP_ADDR_RIKER $cf6f
#DEFINE BITMAP_LENGTH_RIKER 810
#DEFINE BITMAP_ADDR_WORF $d299
#DEFINE BITMAP_LENGTH_WORF 1211
' Free space
#DEFINE BITMAP_ADDR_FREE $d754

' NPCs
#DEFINE NPC_PICARD 0
#DEFINE NPC_RIKER 1
#DEFINE NPC_DATA 2
#DEFINE NPC_GEORDI 3
#DEFINE NPC_WORF 4


' - Vars --------------------------------------------------
DIM Command AS String
DIM Command_Words(5) AS String

DIM Timer AS UInteger AT 23672

' - Shared vars -------------------------------------------
' Next module to RUN
DIM NextModule AS UByte AT VARS_ADDR
DIM Parameter1 AS UByte AT VARS_ADDR + 1
DIM Parameter2 AS UInteger AT VARS_ADDR + 2

' Game configuration
DIM Config_GameLevel AS UByte AT VARS_ADDR + 4
' Status
' StarDate
DIM Status_StarDate AS UInteger AT VARS_ADDR + 5
DIM Status_StarDate_Day AS UBYte AT VARS_ADDR + 7
' Remaining time
DIM Status_TimeLeft AS UByte AT VARS_ADDR + 8
DIM Status_TimeLeft_Day AS UByte AT VARS_ADDR + 9
' Ship condition (0=Green, 1=Yelow, 2=Red)
DIM Status_Condition AS UByte AT VARS_ADDR + 10
' Live support (0-100)
DIM Status_LiveSupport AS UByte AT VARS_ADDR + 11
' Main total ship energy
DIM Status_Energy AS Integer AT VARS_ADDR + 12
' Shields level (0-100)
DIM Status_ShieldLevel AS Byte AT VARS_ADDR + 14
' Shield status, 0=Down, 1=UP
DIM Status_Shield AS Byte AT VARS_ADDR + 15
' Weapons Energy (0-100)
DIM Status_PhasersLevel AS Byte AT VARS_ADDR + 16
' Number of torpedoes (0-100)
DIM Status_Torpedoes AS Byte AT VARS_ADDR + 17

' ColdDown time for torpedoes
DIM Status_TorpedoesColdDown AS Byte AT VARS_ADDR + 18
' Number of main phasers (0-12)
DIM Status_Phasers AS Byte AT VARS_ADDR + 19
' Number of rear phasers (0-2)
'DIM Status_RearPhasers AS Byte AT VARS_ADDR + 20

' Damage
DIM Status_Damage AS Byte AT VARS_ADDR + 20
DIM Status_Damage_Phasers AS BYTE AT VARS_ADDR+21
DIM Status_Damage_Torpedoes AS BYTE AT VARS_ADDR+22
DIM Status_Damage_Warp AS BYTE AT VARS_ADDR+23
DIM Status_Damage_Impulse AS BYTE AT VARS_ADDR+24
DIM Status_Damage_Computer AS BYTE AT VARS_ADDR+25
DIM Status_Damage_Life AS BYTE AT VARS_ADDR+26
DIM Status_Damage_Trasnport AS BYTE AT VARS_ADDR+27
DIM Status_Damage_Shuttle AS BYTE AT VARS_ADDR+28
DIM Status_Damage_Collector AS BYTE AT VARS_ADDR+29
DIM Status_Damage_Sensors AS BYTE AT VARS_ADDR+30
' Ship location
DIM Status_Position_Galaxy_X AS Byte AT VARS_ADDR + 31
DIM Status_Position_Galaxy_Y AS Byte AT VARS_ADDR + 32
DIM Status_Position_Sector_X AS Byte AT VARS_ADDR + 33
DIM Status_Position_Sector_Y AS Byte AT VARS_ADDR + 34
' Warp factor
DIM Status_WarpFactor AS UByte AT VARS_ADDR + 35
' Command buffer (42 bytes)
DIM Command_Buffer AS UByte AT VARS_ADDR + 36
' Command words (16 bytes per command)
DIM Command_Buffer_Word0 AS UByte AT VARS_ADDR + 78
DIM Command_Buffer_Word1 AS UByte AT VARS_ADDR + 94
DIM Command_Buffer_Word2 AS UByte AT VARS_ADDR + 110
DIM Command_Buffer_Word3 AS UByte AT VARS_ADDR + 126
DIM Command_Buffer_Word4 AS UByte AT VARS_ADDR + 142
DIM Command_Buffer_Word5 AS UByte AT VARS_ADDR + 158
' Config
DIM Config_SoundEnabled AS UByte AT VARS_ADDR + 174

' Map
' Galaxy (10x14=140 bytes/quadrants) -> ZZBBSSSD
'   ZZ=Zone: 00=Federation, 01=Romulan, 10=Klingon, 11=Neutral
'   BB=StarBases (0-3)
'   SSS=Stars: numbers of stars (0-7)
'   D=0: Uncharted quadrant
'   Black hole=$ff
DIM Map_Galaxy(MAP_GALAXY_MAXX,MAP_GALAXY_MAXY) AS UByte AT VARS_ADDR + 175
' Sector Map (64x64) generated every jump into sector -> TYPE
DIM Map_Sector(64,64) AS UByte AT $c000
' Las sector visited
DIM Map_LastSectorX AS UByte AT VARS_ADDR + 316
DIM Map_LastSectorY AS UByte AT VARS_ADDR + 317
' Enemies in galaxy (64x3=192)
DIM Enemies_Galaxy(ENEMIES_GALAXY_MAX,2) AS UByte AT VARS_ADDR + 318
' Enemies in sector (9x4=36)
DIM Enemies_Sector(ENEMIES_SECTOR_MAX,8) AS UByte AT VARS_ADDR + 510
' Numer of enemies in galaxy
DIM Enemies_Count AS UByte AT VARS_ADDR + 546

' Sector status
' New scanned sector, 0=Old, 1=New, 2=Supernova
DIM Sector_New AS UByte AT VARS_ADDR + 547
DIM Sector_Zone AS UByte AT VARS_ADDR + 548
DIM Sector_Stars AS UByte AT VARS_ADDR + 549
DIM Sector_StarBases AS UByte AT VARS_ADDR + 550
DIM Sector_Planets AS UByte AT VARS_ADDR + 551
DIM Sector_Planets_M AS UByte AT VARS_ADDR + 552
DIM Sector_Planets_Dilitrium AS UByte AT VARS_ADDR + 553
DIM Sector_Enemies AS UByte AT VARS_ADDR + 554

' Enterprise combat data
DIM Ent_Dir AS UByte AT VARS_ADDR + 555
' Logs (4 x 22 = 88 bytes)
DIM LogsBuffer AS UByte AT VARS_ADDR + 556

' Last VARS_ADDR +644


' - Common subroutines ------------------------------------

' - Wait for release a key, then press and then release ---
SUB WaitKey()
    WHILE INKEY$ <> "" : WEND
    WHILE INKEY$ = "" : WEND
    WHILE INKEY$ <> "" : WEND
END SUB


' - Converts uinteger to String ---------------------------
' Parameters:
'   value (UInteger): Unsigned number to be converted
' Returns:
'   String: The string with the number, like ToString()
FUNCTION ToString(value AS UInteger) AS String
    DIM txt AS String
    DIM v, vr, c AS UInteger

    txt = ""
    vr = value

ToStringBucle:
    v = vr / 10
    IF v = 0 THEN                   ' vr < 10, is the last
        txt = CHR$(48 + vr) + txt
        RETURN txt
    END IF
    c = vr MOD 10
    txt = CHR$(48 + c) + txt        ' Add the MOD result to string
    vr = v
    GOTO ToStringBucle              ' Because I can!
END FUNCTION


' - Converts String to UInteger ---------------------------
' Parameters:
'   text (String): String to convert
' Returns:
'   Integer: String converted to number, 9999 if error
FUNCTION ToNumber(text AS String) AS Integer
    DIM n, l, c AS UByte
    DIM v, s AS Integer
    
    l = LEN(text)
    IF l=0 THEN
        RETURN 9999
    END IF
    l = l - 1
    s = 1
    FOR n = 0 TO l
        c = CODE text(n)
        IF n = 0 THEN
            IF c = $2d THEN
                s = -1
                CONTINUE FOR
            END IF
        END IF
        IF c < $30 OR c > $39 THEN
            IF n = 0 AND c = $2b THEN
                CONTINUE FOR
            END IF
            RETURN 9999
        END IF
        v = (v * 10) + (c - $30)
    NEXT n
    v = v * s
    RETURN v
END FUNCTION


' - ValueBound --------------------------------------------
' Bound a byte value to min and max range
' Parameters:
'   value (Byte): Value to bound
'   min (Byte): Minimun value
'   max (Byte): Maximun value
' Returns:
'   Value in range beetwen min and max
FUNCTION ValueBound(value AS Byte, min AS Byte, max AS Byte) AS Byte
    IF value < min THEN
        value = min
    ELSEIF value > max
        value = max
    END IF
    RETURN value
END FUNCTION


' - Strings and buffers -----------------------------------
SUB Text2Buffer(text AS String, dir AS UInteger, maxL AS UByte = 15)
    DIM n, l AS UByte
    
    l = LEN(text)
    IF l = 0 THEN
        POKE dir,0
        RETURN
    END IF
    l = l - 1
    IF l > maxL THEN
        l = maxL
    END IF
    
    FOR n = 0 TO l
        POKE dir,CODE text(n)
        dir = dir + 1
    NEXT n
    POKE dir,0
END SUB


FUNCTION Buffer2Text(dir AS UInteger, maxL AS UByte = 15) AS String
    DIM txt AS String
    DIM n,c AS UByte
   
    txt = ""
    FOR n = 0 TO maxL
        c = PEEK(dir)
        IF c = 0 THEN
            EXIT FOR
        ELSE
            txt = txt + CHR$(c)
        END IF
        dir = dir + 1
    NEXT n
    RETURN txt
END FUNCTION


' - Get Command and parsed words --------------------------
SUB GetCommandAndWords()
    DIM n AS UByte
    DIM dir AS UInteger
    
    ' Get command and parsed words
    Command = Buffer2Text(@Command_Buffer)
    dir = @Command_Buffer_Word0
    FOR n = 0 TO 5
        Command_Words(n) = Buffer2Text(dir)
        dir = dir + 16
    NEXT n
END SUB


' - Clear buffer command ----------------------------------
SUB ClearCommands()
    DIM n, l AS UByte
    
    FOR n = 0 TO 5
        Command_Words(n) = ""
    NEXT n       
END SUB


' - Send Command and words to buffer ----------------------
SUB SaveCommands()
    DIM n AS UByte
    DIM dir AS UInteger

    ' Send Command and words to buffer
    Text2Buffer(Command,@Command_Buffer)
    dir = @Command_Buffer_Word0
    FOR n = 0 TO 5
        Text2Buffer(Command_Words(n),dir)
        dir = dir + 16
    NEXT n
END SUB


' - Game parameters ---------------------------------------

' - Add days to stelar date -------------------------------
' Calc Status_StarDate if carry
' Parameters:
'   days (UByte): days to add to Status_StarDate_Day
SUB FASTCALL AddDate(days AS UByte)
    Status_StarDate_Day = Status_StarDate_Day + days
    WHILE Status_StarDate_Day > 9
        Status_StarDate_Day = Status_StarDate_Day - 10
        Status_StarDate = Status_StarDate + 1
    WEND
END SUB


SUB FASTCALL GetTotalDamage()
    Status_Damage = ( _
        Status_Damage_Phasers + _
        Status_Damage_Torpedoes + _
        Status_Damage_Warp + _
        Status_Damage_Impulse + _
        Status_Damage_Computer + _
        Status_Damage_Life + _
        Status_Damage_Trasnport + _
        Status_Damage_Shuttle + _
        Status_Damage_Collector + _
        Status_Damage_Sensors)
 END SUB