' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Game module (0) ---------------------------------------
' ---------------------------------------------------------
' Parameters:
'       Parameter1: 0 = Normal
'                   10 = Combat step


' Start calling Game sub
Game()
' Return no Main module
STOP


' - Includes ----------------------------------------------
#INCLUDE "NextLibLite.bas"

#INCLUDE "Common.bas"
#INCLUDE "LCARS_Next.bas"


' - Game --------------------------------------------------
SUB Game()
    DIM cmd AS String

    IF Sector_Enemies > 0 THEN
        IF Parameter1 <> 10 THEN
            NextModule = MODULE_COMBAT
            Parameter1 = 0
            RETURN
        END IF
    END IF
    
    Parameter1 = 0
    Parameter2 = 0
    DO
        Command = ""
        ClearCommands()
        
        LCARS_Input(40)

        ' Check menu options
        IF Command = "1" THEN
            NextModule = MODULE_STATUS
            RETURN
        ELSEIF Command = "2" THEN
            NextModule = MODULE_DAMAGE
            RETURN
        ELSEIF Command = "3" THEN
            NextModule = MODULE_MAP
            RETURN
        ELSEIF Command = "4" THEN
            NextModule = MODULE_NAV
            RETURN
        'ELSEIF Command = "5" THEN
        '    NextModule = MODULE_TACTIC
        '    RETURN
        'ELSEIF Command = "6" THEN
        '    NextModule = MODULE_OPS
        '    RETURN
        'ELSEIF Command = "7" THEN
        '    NextModule = MODULE_CTRL
        '    RETURN
        ELSEIF Command = "8" THEN
            NextModule = MODULE_HELP
            RETURN
        ELSEIF Command = "9" THEN
            Shield_Down()
            RETURN
        ELSEIF Command = "0" THEN
            Red_Alert()
            RETURN        
        END IF

        ' Divide command un words
        ParseCommand()

        ' Check commands
        cmd = Command_Words(0)
        IF cmd = "HELP" OR cmd = "H" THEN
            NextModule = MODULE_HELP
            RETURN
        ELSEIF cmd = "STATUS" OR cmd = "ST" THEN
            NextModule = MODULE_STATUS
            RETURN
        ELSEIF cmd = "DAMAGE" OR cmd = "D" THEN
            NextModule = MODULE_DAMAGE
            RETURN
        ELSEIF cmd = "CHART" OR cmd = "C" OR cmd = "MAP" THEN
            NextModule = MODULE_MAP
            RETURN
        ELSEIF cmd = "LRSCAN" OR cmd = "L" THEN
            NextModule = MODULE_MAP
            Parameter1 = 1
            RETURN
        ELSEIF cmd = "MOVE" OR cmd = "M" OR cmd = "WARP" OR cmd = "W" THEN
            NextModule = MODULE_MAP
            Parameter1 = 3
            RETURN
        ELSEIF cmd = "IMPULSE" OR cmd = "I" THEN
            NextModule = MODULE_NAV
            Parameter1 = 1
            RETURN
        ELSEIF cmd = "RED" OR cmd = "9" THEN
            Red_Alert()
            RETURN
        ELSEIF cmd = "PHASER" OR cmd = "P" THEN
            NextModule = MODULE_NAV
            Parameter1 = 2
        END IF
        
        LCARS_Error("SYNTAX ERROR:TYPE HELP OR PRESS 8 FOR HELP")
    LOOP
END SUB


' - Parser ------------------------------------------------

' - Split command into words filling Command_Word[x] ------
SUB ParseCommand()
    DIM n, l, c, s, e, w AS UByte
    DIM cmd AS String
    DIM dir AS UInteger
    
    ClearCommands()

    l = LEN(Command)
    IF l = 0 THEN
        SaveCommands()
        RETURN
    END IF
    IF l = 1 THEN
        Command_Words(0)=Command
    ELSE    
        l = l - 1
        s = 0
        e = 0
        w = 0
        FOR n = 0 TO l
            c = CODE Command(n)
            IF c = $20 OR c = $2c THEN  ' space OR comma
                e = n - 1
                Command_Words(w) = Command(s TO e)
                s = n + 1
                w = w + 1
                IF w = 6 THEN
                    EXIT FOR
                END IF
            END IF
        NEXT n   
        Command_Words(w) = Command(s)
        IF w <> 6 AND s < l THEN
            Command_Words(w) = Command(s TO)
        END IF
    END IF
    SaveCommands()
END SUB


' - Misc commands -----------------------------------------
SUB Red_Alert()
    Status_Condition = 2
    IF Status_Energy < 100 THEN
        NextModule = MODULE_REPORT
        Parameter1 = 5
    END IF
    Status_Shield = 1
    Status_ShieldLevel = 100
    Status_Energy = Status_Energy - 100
    Status_PhasersLevel = 100
    
    NextModule = MODULE_NAV
    Parameter1 = 0
    
    BankSwitch67(BANK_TACTIC_ENEMY)
    ' TODO: Load tactic images of the correct ship
    LoadSD("data/Birdofprey.Tactic.nspr",$c000,$4000,0) 
    
    BankSwitch67(BANK_LCARS_FONT)
END SUB


SUB Shield_Down()
    Status_Condition = 0
END SUB