' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Help module (3) ---------------------------------------
' ---------------------------------------------------------
' Parameters:
'   Command_Words(1): Command to help


' Start calling Game sub
Help()
' Return no Main module
STOP


' - Includes ----------------------------------------------
#INCLUDE "NextLibLite.bas"

#INCLUDE "Common.bas"
#INCLUDE "LCARS_Next.bas"
#INCLUDE "LCARS_Help_Next.bas"


' - Help --------------------------------------------------
SUB Help()
    DIM n AS UByte
    DIM dir AS UInteger
    DIM cmd AS String
    
    NextModule = MODULE_GAME

    LCARS_SelectMenu(OPT_HELP)
    LCARS_Clear()
    
    LCARS_Help()
    
    GetCommandAndWords()
    
    ' Help for...
    cmd = Command_Words(1)
    IF LEN(cmd) = 0 THEN
        LCARS_HelpPrint("LIST OF ACCEPTED COMMANDS",15)
        '                012345678901234567890123456789012345678901
        LCARS_HelpPrint("CHART          DAMAGE         HELP",255)
        LCARS_HelpPrint("IMPULSE        LRSCAN         MAP",255)
        LCARS_HelpPrint("MOVE           STATUS         WARP",255)
        RETURN
    ELSEIF cmd = "HELP" OR cmd = "H" OR cmd = "?" THEN
        RESTORE Help_HELP
    ELSEIF cmd = "STATUS" OR cmd = "ST" THEN
        RESTORE Help_STATUS
    ELSEIF cmd = "CHART" OR cmd = "C" OR cmd = "MAP" THEN
        RESTORE Help_MAP
    ELSEIF cmd = "LRSCAN" OR cmd = "L" THEN
        RESTORE Help_LRSCAN
    ELSEIF cmd = "MOVE" OR cmd = "M" OR cmd = "WARP" OR cmd = "W" THEN
        RESTORE Help_WARP
    ELSEIF cmd = "DAMAGE" OR cmd = "D" THEN
        RESTORE Help_DAMAGE
    ELSEIF cmd = "IMPULSE" OR cmd = "I" THEN
        RESTORE Help_IMPULSE
    ELSE
        LCARS_HelpPrint(cmd+" IS AN UNACCEPTED COMMAND",232)
        RETURN
    END IF

    ClearCommands()
    SaveCommands()
    
    ShowHelp()
END SUB


' - Show help from RESTORE point --------------------------
' * for page feed
' # for end of text
SUB ShowHelp()
    DIM txt AS String
    
    DO
        READ txt
        IF txt = "#" THEN
            RETURN
        ELSEIF txt = "*"
            WaitKey()
            LCARS_Clear()
        ELSE
            LCARS_HelpPrint(txt,255)
        END IF
    LOOP
END SUB


' - Help data ---------------------------------------------
Help_HELP:
'     012345678901234567890123456789012345678901
DATA "COMMAND: HELP"
DATA "ALIAS: HELP, H, 8"
DATA "ENERGY COST: NONE"
DATA ""
DATA "THIS COMMAND DISPLAYS A LIST OF THE"
DATA "COMMANDS RECOGNIZED BY THE SYSTEM."
DATA "IF AN ADDITIONAL WORD ID PROVIDED, THE"
DATA "HELP FOR THAT COMMAND IS DISPLAYED."
DATA "#"

Help_STATUS:
'     012345678901234567890123456789012345678901
DATA "COMMAND: STATUS"
DATA "ALIAS: STATUS, ST, 1"
DATA "ENERGY COST: NONE"
DATA ""
DATA "THIS COMMAND DISPLAYS INFORMATION ABOUT"
DATA "THE CURRENT STATUS OF YOU STARSHIP."
DATA "THE INFORMATION DISPLAYED IS AS FOLLOWS:"
DATA "* CONTION OF THE SHIP: GREEN,YELLOW OR RED"
DATA "* MAIN ENERGY LEVEL"
DATA "* SHIELDS STATE AND ENERGY LEVEL"
DATA "* WEAPONS ENERGY LEVEL"
DATA "* LIFE SUPPORT STATUS"
DATA "* NUMBER OF REMAINING TORPEDOES"
DATA ""
DATA ""
DATA "                               CONTINUE..."
DATA "*"
DATA "* NUMBER OF PRIMARY AND REAR PHASERS"
DATA "    OPERATIONAL, AS WELL AS THE TOTAL"
DATA "    NUMBER OF PHASERS."
DATA "* NUMBER OF OPERATIONAL TORPEDO LAUNCHERS"
DATA "    AND NUMBER OF TOTAL TORPEDO LAUNCHERS"
DATA "* CURRENT STARDATE"
DATA "* REMAINING STARDATES TO COMPLETE THE"
DATA "    MISSION"
DATA "#"

Help_MAP:
'     012345678901234567890123456789012345678901
DATA "COMMAND: CHART"
DATA "ALIAS: CHART, C, 3, MAP"
DATA "ENERGY COST: NONE"
DATA ""
DATA "THIS COMMAND DISPLAYS THE GALAXY MAP."
DATA "THE KNOWN GALAXY IS DIVIDED INTO AN 8 X 8"
DATA "GRID OF SECTORS."
DATA "EACH SECTOR DISPLAYS THREE VALUES."
DATA "THE UNEXPLORED SECTORS OR THOSE FOR WHICH"
DATA "NO DATA IS KNOWN SHOW THE VALUE WITH A"
DATA "DOT."
DATA "THE FIRST DIGIT INDICATES THE NUMBER OF"
DATA "ENEMIES DETECTED IN THE SECTOR."
DATA "THE SECOND NUMBER INDICATES THE NUMBER OF"
DATA "FEDERATION BASES LOCATED IN THE SECTOR."
DATA "                               CONTINUE..."
DATA "*"
DATA "THE THIRD ONE THE NUMBER OF STARS IN THE"
DATA "SECTOR."
DATA ""
DATA "THREE ASTERISKS INDICATE THAT THE SECTOR"
DATA "CONTAINS A SUPERNOVA AND SHOULD NOT BE"
DATA "VISITED UNDER ANY CIRCUMSTANCES."
DATA "#"

Help_LRSCAN:
'     012345678901234567890123456789012345678901
DATA "COMMAND: LRSCAN"
DATA "ALIAS: LRSCAN, L"
DATA "ENERGY COST: NONE"
DATA ""
DATA "PERFORM A LONG-RANGE SCAN COMPRISING THE"
DATA "CURRENT GALAXY QUADRANT, PLUS THE 8"
DATA "QUADRANTS SURROUNDING THE ENTERPRISE."
DATA "THIS COMMAND DISPLAYS THE GALAXY MAP WITH"
DATA "UPDATED INFORMATION."
DATA "SHIPS UTILIZING A CLOAKING DEVICE WILL NOT"
DATA "BE DISPLAYED ON THE MAP."
DATA "#"

Help_WARP:
'     012345678901234567890123456789012345678901
DATA "COMMAND: MOVE"
DATA "ALIAS: MOVE, M, WARP, W"
DATA "ENERGY COST: DEPENDS ON THE DISTANCE AND"
DATA "WARP SPEED."
DATA "SYNTAX: "
DATA "  WARP A 1 2,3"
DATA "    MOVE TO SECTOR 2,3 AT WARP SPEED 1"
DATA ""
DATA "  WARP M 1 2,-3"
DATA "    MOVE 2 SECTORS X AND -3 SECTORS Y AT"
DATA "    WARP SPEED 1"
DATA "MODE A (AUTO) USES THE SHIP'S COMPUTER TO"
DATA "MOVE US TO THE INDICATED SECTOR."
DATA "MODE M (MANUAL) MOVES US RELATIVELY +X AND"
DATA "+Y SECTORS.                    CONTINUE..."
DATA "*"
DATA "WE CAN TRAVEL FROM WARP 1 TO WARP 10."
DATA "THE OPTIMAL NORMAL SPEED IS WARP 5."
DATA "HIGHER SPEED CONSUMES LESS TIME BUT MORE"
DATA "ENERGY AND CAN DAMAGE THE ENGINE."
DATA "A LOWER SPEED CONSUMES LESS ENERGY AND"
DATA "DOES NOT AFFECT THE ENGINE AS MUCH."
DATA ""
DATA "AUTOMATIC MODE CANNOT BE USED IF THE"
DATA "COMPUTER IS TOO DAMAGED."
DATA "#"

Help_DAMAGE:
'     012345678901234567890123456789012345678901
DATA "COMMAND: DAMAGE"
DATA "ALIAS: DAMAGE, D, 2"
DATA ""
DATA "THIS COMMAND DISPLAYS A DAMAGE REPORT OF"
DATA "THE ENTERPRISE. IT IS BASED ON A REPORT"
DATA "OF THE 10 ESSENTIAL PARTS OF THE SHIP AND"
DATA "A TOTAL VALUE OF IT."
DATA ""
DATA "THE DAMAGES ARE GRADUALLY BEING REPAIRED"
DATA "BY THE ENTERPRISE PERSONNEL AND THE SHIP"
DATA "SELF-REPAIR SYSTEMS, BUT IF IT REACHES A"
DATA "CRITICAL LEVEL, THE SHIP WILL BE"
DATA "DESTROYED."
DATA "#"


Help_IMPULSE:
'     012345678901234567890123456789012345678901
DATA "COMMAND: MOVE"
DATA "ALIAS: IMPULSE, I"
DATA "ENERGY COST: DEPENDS ON THE DISTANCE."
DATA "SYNTAX: "
DATA "  IMPULSE A 2,3"
DATA "    MOVE TO CELL 2,3 INTO ACTUAL SECTOR"
DATA ""
DATA "  IMPULSE M 2,-3"
DATA "    MOVE 2 CELLS X AND -3 CELLSE Y."
DATA ""
DATA "MODE A (AUTO) USES THE SHIP'S COMPUTER TO"
DATA "MOVE US TO THE INDICATED CELL."
DATA "MODE M (MANUAL) MOVES US RELATIVELY +X AND"
DATA "+Y CELLS."
DATA "AUTOMATIC MODE CANNOT BE USED IF THE"
DATA "COMPUTER IS TOO DAMAGED."
DATA "#"
