' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Intro module (1) --------------------------------------
' ---------------------------------------------------------
' Parameters: None


' Start calling Game sub
'BBREAK
Intro()
' Return no Main module
STOP


' - Defines -----------------------------------------------
'#DEFINE SKIPINTRO


' - Includes ----------------------------------------------
#INCLUDE <memcopy.bas>
#INCLUDE <retrace.bas>
#INCLUDE "NextLibLite.bas"

#INCLUDE "Common.bas"
#INCLUDE "LCARS_Next.bas"
#INCLUDE "LCARS_Video_Next.bas"
#INCLUDE "LCARS_Intro_Next.bas"
#INCLUDE "LCARS_Map_Next.bas"


' - Intro of the game -------------------------------------
SUB Intro()
    DIM k, gameLevel AS UByte
    DIM x, y, x1, n, num AS UByte
    DIM dir AS UInteger
    
    Config_SoundEnabled = 0

    LCARS_Init()    
    LCARS_DrawMain()
    LCARS_Intro()

#IFDEF SKIPINTRO
    gameLevel = 1
    WaitKey()    
#ELSE
    ' New or Load
    Select_Option("(N)EW GAME OR (L)OAD GAME ", "NL")
    LCARS_Input(1)
    IF Command = "L" THEN
        ' TODO: Load game
    END IF
    
    ' Game level
    Select_Option("LEVEL 1(EASY) - 5(HARD)  ", "12345")
    LCARS_Input(1)
    gameLevel = (CODE Command) - 48
#ENDIF

NewGame:
    ' New game
    RANDOMIZE 0
    Config_GameLevel = gameLevel
    ' Dates
    Status_StarDate = (RND * 6000) + 41153
    Status_StarDate_Day = 0
    Status_TimeLeft = (((6-gameLevel) * 7) + INT(RND * 3)) - 1
    Status_TimeLeft_Day = 0
    ' Status
    Status_Condition = CONDITION_GREEN
    Status_LiveSupport = 100
    ' Energy
    Status_Energy = 5000
    Status_ShieldLevel = 100
    Status_Shield = 0
    Status_PhasersLevel = 100
    ' Damage
    Status_Damage_Phasers = 0
    Status_Damage_Torpedoes = 0
    Status_Damage_Warp = 0
    Status_Damage_Impulse = 0
    Status_Damage_Computer = 0
    Status_Damage_Life = 0
    Status_Damage_Trasnport = 0
    Status_Damage_Shuttle = 0
    Status_Damage_Collector = 0
    Status_Damage_Sensors = 0
    GetTotalDamage()
    ' Weapons
    Status_Torpedoes = 50
    Status_TorpedoesColdDown = 0
    Status_Phasers = 12
    
    ' Galaxy map
    dir = @Map_Galaxy
    FOR y = 0 TO MAP_GALAXY_MAXY
        FOR x = 0 TO MAP_GALAXY_MAXX
            Map_Galaxy(x,y) = 0
        NEXT x
    NEXT y
    
    ' Zones
    RESTORE FrontierData
    FOR y = 0 TO MAP_GALAXY_MAXY
        x1 = MAP_GALAXY_MAXX - 2
        FOR x = 0 TO 2
            READ num
            Map_Galaxy(x1,y) = num
            x1 = x1 + 1
        NEXT x
    NEXT y
    
    ' Position
    DO
        Status_Position_Galaxy_X = INT(RND * 5) + 1
        Status_Position_Galaxy_Y = INT(RND * 5) + 1
        IF Map_Galaxy(Status_Position_Galaxy_X,Status_Position_Galaxy_Y) <> $ff THEN
            EXIT DO
        END IF
    LOOP
    Map_LastSectorX = 255
    Map_LastSectorY = 255
    Sector_New = 0

    ' Enemies
    ' Reset all enemies
    FOR n = 0 TO ENEMIES_GALAXY_MAX
        Enemies_Galaxy(n,ENEMIES_GALAXY_TYPE) = 0
    Next n
    ' Create some enemies
    Enemies_Count = Config_GameLevel * (10 + INT(RND * 3))
    FOR n = 0 TO Enemies_Count
        Enemies_Galaxy(n,ENEMIES_GALAXY_TYPE) = INT(RND * 2) + 1
        Enemies_Galaxy(n,ENEMIES_GALAXY_X) = RND * MAP_GALAXY_MAXX
        Enemies_Galaxy(n,ENEMIES_GALAXY_Y) = RND * MAP_GALAXY_MAXY
    NEXT n
        
    Map_Create(Config_GameLevel)    
    
#IFNDEF SKIPINTRO    
    ' Incomming communication
    LCARS_SelectMenu(OPT_CTRL)    
    LCARS_NewGame()
#ENDIF

    ' Launch Status
    ' NextModule = MODULE_DAMAGE
    NextModule = MODULE_STATUS
    Parameter1 = 1
END SUB


' - Command prompt ----------------------------------------
SUB Select_Option(text AS String, options AS String)
    DIM cmd, txt AS String
    DIM n, l AS UByte

    l = LEN(options) - 1

    DO
        LCARS_NewGamePrint("                         ")
        LCARS_NewGamePrint(text)

        LCARS_Input(1)   
        IF LEN(Command)>0 THEN
            cmd = Command(0)        
            FOR n = 0 TO l
                IF cmd = options(n) THEN
                    RETURN
                END IF
            NEXT n
        END IF

        txt = "BAD COMMAND: "
        FOR n = 0 TO l
            IF n <> 0 THEN
                txt = txt + ","+options(n)
            ELSE
                txt = txt + options(n)
            END IF
        NEXT n
        LCARS_Error(txt)
    LOOP
END SUB


FrontierData:
DATA 192, 64, 64
DATA 192, 64, 64
DATA 192,192, 64
DATA   0,192, 64
DATA   0,192, 64
DATA 192,192, 64
DATA 192, 64, 64
DATA 192,192, 64
DATA   0,  0,128
DATA   0,128,128
DATA   0,128,128
DATA   0,  0,128
DATA   0,128,128
DATA 128,128,128
