' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS Intro for Next ----------------------------------


' - Show game intro ---------------------------------------
SUB LCARS_Intro()
    DIM txt AS String
    DIM n, m AS UByte
    
    LCARS_SelectMenu(OPT_CTRL)
    LCARS_Clear()
    
    PrintText816_RTTY(56,LCARS_Y1,"LCARS Z80N V0.5-ALPHA",212,0)

    LCARS_Starfleet_Logo(LCARS_XM - 64,LCARS_Y1+16)   

    txt = "LOADING, PLEASE WAIT"
    PrintText816_RTTY(44,LCARS_Y1+16+128,txt,212,0)
    
    FOR n = 0 TO 6
        BankSwitch67(BANK_LCARS_FONT)
        PrintFont816(44,LCARS_Y1+16+128,txt,212,0)
        txt = txt + "."
        
        IF n = 0 THEN
            ' Load Damage
            NextRegA($56,BANK_BITMAPS1)
            LoadSD("data/Damages.nbmp",BITMAP_ADDR_DAMAGE,BITMAP_LENGTH_DAMAGE,0)
        ELSEIF n = 1 THEN
            ' Load Warp animation
            LCARS_Video_LoadAnimation("data/warp.nvid",BANK_VIDEO_WARP,53)
        ELSEIF n = 2 THEN
            ' Load Data
            NextRegA($56,BANK_BITMAPS1)
            LoadSD("data/Data.nbmp",BITMAP_ADDR_DATA,BITMAP_LENGTH_DATA,0)
            ' Load Geordi
            NextRegA($56,BANK_BITMAPS1)
            LoadSD("data/Geordi.nbmp",BITMAP_ADDR_GEORDI,BITMAP_LENGTH_GEORDI,0)
            ' Load Picard
            NextRegA($56,BANK_BITMAPS1)
            LoadSD("data/Picard.nbmp",BITMAP_ADDR_PICARD,BITMAP_LENGTH_PICARD,0)
        ELSEIF n = 3 THEN
            ' Load Riker
            NextRegA($56,BANK_BITMAPS1)
            LoadSD("data/Riker.nbmp",BITMAP_ADDR_RIKER,BITMAP_LENGTH_RIKER,0)
            ' Load Worf
            NextRegA($56,BANK_BITMAPS1)
            LoadSD("data/Worf.nbmp",BITMAP_ADDR_WORF,BITMAP_LENGTH_WORF,0)           
        ELSEIF n = 4 THEN
            ' Tiles for MAP option
            BankSwitch67(BANK_LCARS_GRID)
            LoadSD("data/Grid.ntil",$c000,$4000,0)
            ' Sprites for combat background
            BankSwitch67(BANK_COMBAT_BACKGROUND)
            LoadSD("data/Space.nspr",$c000,$4000,0)
        ELSEIF n = 5 THEN
            ' Sprites for combat Enterprise
            BankSwitch67(BANK_COMBAT_SHIPS)
            LoadSD("data/Ships.nspr",$c000,$4000,0) 
            ' Sprites for tactic Enterprise
            BankSwitch67(BANK_TACTIC_ENTERPRISE)
            LoadSD("data/Enterprise-D.Tactic.nspr",$c000,$4000,0) 
        ELSEIF n = 6 THEN
        ELSE
            FOR m = 0 TO 20
                waitretrace
            NEXT m
        END IF
    NEXT n
    BankSwitch67(BANK_LCARS_FONT)   
END SUB


' - Print StarFlet logo -----------------------------------
SUB LCARS_Starfleet_Logo(x AS UByte, y AS UByte)
    BankSwitch67(BANK_TEMP)
    LoadSD("data/Starfleet.nspr",$c000,$4000,0)
   
    LCARS_PrintBlock44(x,y,0)
    LCARS_PrintBlock44(x+64,y,16)
    LCARS_PrintBlock44(x,y+64,32)
    LCARS_PrintBlock44(x+64,y+64,48)
    
    BankSwitch67(BANK_LCARS_FONT)
END SUB


' - Intro for new game ------------------------------------
SUB LCARS_NewGame()
    LCARS_Clear()
     
    LCARS_ShowImage(LCARS_X1,LCARS_Y1,BANK_BITMAPS1,BITMAP_ADDR_PICARD)
    
    PrintText816_RTTY(LCARS_X1+50,LCARS_Y1+8,"CAPTAIN'S LOG",15,0)
    PrintText816_RTTY(LCARS_X1+50,LCARS_Y1+32,"STARDATE " + ToString(Status_StarDate) + "." + _
        ToString(Status_StarDate_Day),255,0)
    LCARS_PrintY = LCARS_Y1 + 61
    '            01234567890123456789012345 (44)
    LCARS_Print("THE ENTERPRISE IS HEADING",212)
    LCARS_Print("TOWARDS THE NEUTRAL ZONE",212)
    LCARS_Print("DUE TO AN UNUSUAL INCREASE",212)
    LCARS_Print("OF ROMULAN ACTIVITY IN THE",212)
    LCARS_Print("SECTOR.",212)

    WaitKey()
    LCARS_Clear()
    LCARS_Print("THE REPORTS INDICATE THAT",212)
    LCARS_Print("A REBEL FACTION MAY HAVE",212)
    LCARS_Print("TAKEN CONTROL OF A LARGE",212)
    LCARS_Print("PART OF THE EMPIRE THANKS",212)
    LCARS_Print("TO AN ALLIANCE WITH SOME",212)
    LCARS_Print("KLINGON REBEL CLANS.",212)
    LCARS_Print("",212)
    LCARS_Print("WE HAVE LOST CONTACT WITH",212)
    LCARS_Print("TWO COLONIES IN THE",212)
    LCARS_Print("BESTA-ANOMIS SYSTEM.",212)
    WaitKey()
    LCARS_Clear()
    LCARS_Print("WE CANNOT RULE OUT THAT",212)
    LCARS_Print("THEY ARE RECEIVING SUPPORT",212)
    LCARS_Print("FROM OTHER GROUPS, THE",212)
    LCARS_Print("REPORTS ARE CONFUSING.",212)
    LCARS_Print("",212)
    LCARS_Print("WE MUST PROCEED WITH",212)
    LCARS_Print("EXTREME CAUTION AND",212)
    LCARS_Print("FIRMNESS.",212)
    
    PrintFont48(LCARS_X1,LCARS_Y2-16,"TIP: TYPE HELP OR PRESS 8",16,0)

    WaitKey()
END SUB


' - Print a line of text on New game option ---------------
SUB LCARS_NewGamePrint(txt AS String)
    PrintText816_RTTY(44,LCARS_Y1+16+128,txt,212,0)
END SUB

