' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS Map for Next ------------------------------------
' ---------------------------------------------------------


' - Draws the maps ----------------------------------------
SUB LCARS_Map()
    DIM n AS UByte

    PrintFont88(LCARS_X1-2,LCARS_Y1,"a",245,0)
    PrintFont48(LCARS_X1+7,LCARS_Y1,"GALAXY MAP  ENTERPRISE:" + ToString(Status_Position_Galaxy_X+1) + "," + ToString(Status_Position_Galaxy_Y+1),245,0)
    PrintFont88(LCARS_X1+57,LCARS_Y1,"c",245,0)
    PrintFont88(LCARS_X1+153,LCARS_Y1,"ccccccf",245,0)
    PrintFont88(LCARS_X1+185,LCARS_Y1+8,"jcc",245,0)
    
    FOR n = LCARS_Y1 + 16 TO LCARS_Y2 STEP 8
        PrintFont88(LCARS_X1+193,n,"cc",245,0)
    NEXT n
    
    LCARS_Map_Galaxy(LCARS_X1+8,LCARS_Y1+9)   
END SUB


' - Print the galaxy map ----------------------------------
SUB LCARS_Map_Galaxy(x AS UByte, y AS UByte)
    DIM xx, yy, xm, ym, d, a, n, bg, v, numEne AS UByte
    DIM dir AS UInteger
    DIM txt AS String
    
    xx = x
    yy = y + 9
    FOR ym = 0 TO MAP_GALAXY_MAXY + 1
        IF ym < MAP_GALAXY_MAXY + 1 THEN
            IF ym >= 9 THEN
                PrintFont48(xx-5, yy + 1, ToString(ym+1),61,0) 
            ELSE
                PrintFont48(xx, yy + 1, ToString(ym+1),61,0) 
            END IF
        END IF
        L2_LineH(xx, yy, ((MAP_GALAXY_MAXX+1)*17)+6,36)
        yy = yy + 9
    NEXT ym
    
    xx = x + 5
    yy = y + 4   
    FOR xm = 0 TO MAP_GALAXY_MAXX + 1
        IF xm < MAP_GALAXY_MAXX + 1 THEN
            IF xm >= 9 THEN
                PrintFont48(xx + 5,yy-3,ToString(xm+1),61,0) 
            ELSE
                PrintFont48(xx + 7,yy-3,ToString(xm+1),61,0) 
            END IF
        END IF
        L2_LineV(xx, yy, ((MAP_GALAXY_MAXY+1)*9)+5, 36)
        xx = xx + 17
    NEXT xm
    
    xx = x
    yy = y + 10
    FOR ym = 0 TO MAP_GALAXY_MAXY
        xx = x + 7
        FOR xm = 0 TO MAP_GALAXY_MAXX
            d = Map_Galaxy(xm,ym)
            bg = 0
            ' Check out of federation space
            IF d bAND %11000000 THEN                
                IF (d bAND %11000000) = %01000000 THEN
                    ' Romulan empire
                    bg = 8                
                ELSEIF (d bAND %11000000) = %10000000 THEN
                    ' Kinglon empire
                    bg = 128 
                ELSEIF d = $ff THEN
                    bg = 0
                ELSE
                    ' Neutral zone
                    bg = 73
                END IF
                PrintFont88(xx-1,yy,"  ",227,bg)
            END IF
            bg = 0
            ' Uncharted
            IF (d bAND %1) = 0 THEN
                txt = "..."
                PrintFont48(xx,yy,txt,255,bg)
                ' Starbase
                v = (d bAND %00110000) >> 4
                IF v <> 0 THEN                
                    PrintFont48(xx+5,yy,ToString(v),15,bg)
                END IF    
            ELSE
                IF d = 255 THEN
                    ' Supernova
                    PrintFont48(xx,yy,"***",224,bg)
                ELSE
                    ' Stars
                    v = (d bAND %1110) >> 1
                    PrintFont48(xx+10,yy,ToString(v),248,bg)
                    ' Starbases
                    v = (d bAND %00110000) >> 4
                    IF v = 0 THEN
                        PrintFont48(xx+5,yy,"0",15,bg)                        
                    ELSE
                        PrintFont48(xx+5,yy,ToString(v),15,bg)
                    END IF
                    ' Enemies
                    numEne = 0
                    FOR n = 0 TO ENEMIES_GALAXY_MAX
                        IF Enemies_Galaxy(n,ENEMIES_GALAXY_TYPE) <> 0 THEN
                            IF Enemies_Galaxy(n,ENEMIES_GALAXY_X) = xm THEN
                                IF Enemies_Galaxy(n,ENEMIES_GALAXY_Y) = ym THEN
                                    numEne = numEne + 1
                                END IF
                            END IF
                        END IF
                    NEXT n
                    PrintFont48(xx,yy,str(numEne),224,bg)
                END IF
            END IF
            xx = xx + 17
        NEXT xm
        yy = yy + 9
    NEXT ym
  
    xx = x
    yy = y + ((MAP_GALAXY_MAXY+2) * 9) + 2
    PrintFont48(xx - 5,yy,"1.. ENEMIES",224,0)
    PrintFont48(xx +60,yy,".1. STARBASES",15,0)
    PrintFont48(xx +130,yy,"..1 STARS",248,0)
    PrintFont48(xx + 1,yy + 8,"ROMULAN",8,0)
    PrintFont48(xx + 57,yy + 8,"KLINGON",128,0)
    PrintFont48(xx + 115,yy + 8,"NEUTRAL ZONE",73,0)
    PrintFont48(xx - 5, yy+8," ",0,8)
    PrintFont48(xx +51, yy+8," ",0,128)
    PrintFont48(xx +109, yy+8," ",0,73)
    
    xx = x + ((Status_Position_Galaxy_X + 1)* 17) - 12
    yy = y + ((Status_Position_Galaxy_Y + 1) * 9)
    L2_Box(xx,yy,17,9,255)
END SUB


' - Create an entire Galaxy Map ---------------------------
SUB Map_Create(level AS UByte)
    DIM n, r, x, y, s AS UByte
    DIM maxStarBases, numStarBases AS UByte    
    
    ' Limits
    maxStarBases = (5 - level) + 1
    numStarBases = 0
    
    ' Create 150 stars
    FOR n = 1 TO 150        
        ' Locate system
        x = RND * MAP_GALAXY_MAXX
        y = RND * MAP_GALAXY_MAXY      
        s = Map_Galaxy(x,y)
        ' Add StarBase
        IF numStarBases < maxStarBases THEN
            ' Databases only in federation zone and 1 starbase per sector
            IF (s bAND %11010000) = 0 THEN
                numStarBases = numStarBases + 1
                s = s bOR %00010000
            END IF
        END IF
        ' Add Stars
        's = s bOR INT(RND * 16) ' Up to 7 stars
        s = s bOR INT(RND * 8)   ' Up to 4 stars
        s = s bAND %11111110
        Map_Galaxy(x,y) = s
    NEXT n
    
    ' Black Holes
    FOR n = 1 TO level
        ' Locate system
        x = RND * MAP_GALAXY_MAXX - 4
        y = RND * MAP_GALAXY_MAXY
        Map_Galaxy(x,y) = $ff
    NEXT n
END SUB


' - Create a new sector -----------------------------------
SUB LCARS_MAP_CreateSector()
    DIM x, y, n, d, num, t AS UByte
    DIM enemies, stars AS UByte
    
    IF Sector_New = 2 THEN
        RETURN
    END IF
    
    IF Map_LastSectorX = Status_Position_Galaxy_X THEN
        IF Map_LastSectorY = Status_Position_Galaxy_Y THEN
            Sector_New = 0
            RETURN
        END IF
    END IF
    
    ' Reset counters
    Sector_New = 1
    Map_LastSectorX = Status_Position_Galaxy_X
    Map_LastSectorY = Status_Position_Galaxy_Y
    Sector_Zone = 0
    Sector_Stars = 0
    Sector_StarBases = 0
    Sector_Planets = 0
    Sector_Planets_M = 0
    Sector_Planets_Dilitrium = 0
    Sector_Enemies = 0

    ' Mark actual sector as explored
    BankSwitch67(BANK_SECTOR_MAP)
    d = Map_Galaxy(Status_Position_Galaxy_X,Status_Position_Galaxy_Y)
    d = d bOR %1
    Map_Galaxy(Status_Position_Galaxy_X,Status_Position_Galaxy_Y) = d
    
    ' Clear sector map    
    FOR y = 0 TO MAP_SECTOR_MAXY
        FOR x = 0 TO MAP_SECTOR_MAXX
            Map_Sector(x,y) = MAP_OBJECT_NONE
        NEXT x
    NEXT y
    
    ' Clear enemies on sector
    FOR n = 0 TO ENEMIES_SECTOR_MAX
        Enemies_Sector(n,0) = 0
    NEXT n

    ' Extract sector data from Galaxy map
    ' Supernova
    IF d = $ff THEN
        FOR y = 0 TO MAP_SECTOR_MAXY
            FOR x = 0 TO MAP_SECTOR_MAXX
                Map_Sector(x,y) = MAP_OBJECT_SUPERNOVA
            NEXT x
        NEXT y
        Sector_New = 2
        RETURN 
    END IF
    
    ' Zone ZZ000000
    Sector_Zone = (d bAND %11000000) >> 6

    ' Federation zone
    IF Sector_Zone = ZONE_FEDERATION THEN
        ' Enemies
        FOR n = 0 TO ENEMIES_GALAXY_MAX
            IF Enemies_Galaxy(n,ENEMIES_GALAXY_TYPE) <> 0 THEN
                IF Enemies_Galaxy(n,ENEMIES_GALAXY_X) = Status_Position_Galaxy_X THEN
                    IF Enemies_Galaxy(n,ENEMIES_GALAXY_Y) = Status_Position_Galaxy_Y THEN
                        Sector_Enemies = Sector_Enemies + 1
                        LCARS_MAP_Sector_Enemy(Enemies_Galaxy(n,ENEMIES_GALAXY_TYPE))
                    END IF
                END IF
            END IF
        NEXT n
        ' StarBases 00BB0000
        Sector_StarBases = (d bAND %00110000) >> 4
        FOR n = 0 TO Sector_StarBases
            LCARS_MAP_Sector_AddObject(MAP_OBJECT_STARBASE)
        NEXT n
        ' Stars 0000SSS0
        Sector_Stars = (d bAND %00001110) >> 1
        IF Sector_Stars <> 0 THEN
            FOR n = 0 TO Sector_Stars
                t = INT (RND * 2) + MAP_OBJECT_STAR_RED
                LCARS_MAP_Sector_AddObject(t)
            NEXT n
            ' Planets
            Sector_Planets = Sector_Stars * 4
            IF Sector_Planets > 9 THEN
                Sector_Planets = 9
            END IF
            FOR n = 0 TO Sector_Planets
                t = INT (RND * 5) + MAP_OBJECT_PLANET_0
                IF t = MAP_OBJECT_PLANET_M THEN
                    Sector_Planets_M = Sector_Planets_M + 1
                ELSEIF t = MAP_OBJECT_PLANET_DILITRIUM THEN
                    Sector_Planets_Dilitrium = Sector_Planets_Dilitrium + 1
                END IF
                LCARS_MAP_Sector_AddObject(t)
            NEXT n
        END IF
    ' Other zones
    ELSE
        ' Enemies
        Sector_Enemies = ENEMIES_SECTOR_MAX
        FOR n = 0 TO ENEMIES_SECTOR_MAX
            IF Sector_Zone = 1 THEN
                LCARS_MAP_Sector_Enemy(ENEMIES_TYPE_KLINGON)
            ELSE
                LCARS_MAP_Sector_Enemy(ENEMIES_TYPE_ROMULAN)
            END IF
        NEXT n
        ' Stars
        Sector_Stars = INT(RND * 8) + 1
        IF Sector_Stars <> 0 THEN
            FOR n = 0 TO Sector_Stars
                t = INT (RND * 2) + MAP_OBJECT_STAR_RED
                LCARS_MAP_Sector_AddObject(t)
            NEXT n
            ' StarBases 0
            ' Planets
            Sector_Planets = Sector_Stars * 4
            IF Sector_Planets > 9 THEN
                Sector_Planets = 9
            END IF
            FOR n = 0 TO Sector_Planets
                t = RND * 100
                IF t > 90 THEN
                    t = MAP_OBJECT_PLANET_DILITRIUM
                ELSE
                    t = INT (RND * 4) + MAP_OBJECT_PLANET_0
                END IF
                LCARS_MAP_Sector_AddObject(t)
                IF t = MAP_OBJECT_PLANET_M THEN
                    Sector_Planets_M = Sector_Planets_M + 1
                ELSEIF t = MAP_OBJECT_PLANET_DILITRIUM THEN
                    Sector_Planets_Dilitrium = Sector_Planets_Dilitrium + 1
                END IF
            NEXT n
            Sector_Planets = Sector_Planets - Sector_Planets_M - Sector_Planets_Dilitrium
        END IF
    END IF
                    
    ' Set Enterprise position
    FOR n = 0 TO 254
        x = RND * MAP_SECTOR_MAXX
        y = RND * MAP_SECTOR_MAXY
        IF Map_Sector(x,y) = MAP_OBJECT_NONE THEN
            Status_Position_Sector_X = x
            Status_Position_Sector_Y = y
            Ent_Dir = RND * 4
            EXIT FOR
        END IF
    NEXT n
    
    BankSwitch67(BANK_LCARS_FONT)
END SUB


' - Add an object to the sector map -----------------------
SUB LCARS_MAP_Sector_AddObject(t AS UByte)
    DIM n, x, y AS UByte
    
    FOR n = 0 TO 254
        x = RND * MAP_SECTOR_MAXX
        y = RND * MAP_SECTOR_MAXY
        IF Map_Sector(x,y) = MAP_OBJECT_NONE THEN
            Map_Sector(x,y) = t
            RETURN
        END IF
    NEXT n
END SUB


' - Add an enemy to the sector map ------------------------
SUB LCARS_MAP_Sector_Enemy(t AS UByte)
    DIM n, m, x, y AS UByte
    
    FOR n = 0 TO 254
        x = RND * MAP_SECTOR_MAXX
        y = RND * MAP_SECTOR_MAXY
        IF Map_Sector(x,y) = MAP_OBJECT_NONE THEN
            Map_Sector(x,y) = t
            FOR m = 0 TO ENEMIES_SECTOR_MAX
                IF Enemies_Sector(m,ENEMIES_SECTOR_TYPE) = 0 THEN
                    Enemies_Sector(m,ENEMIES_SECTOR_TYPE) = t
                    Enemies_Sector(m,ENEMIES_SECTOR_X) = x
                    Enemies_Sector(m,ENEMIES_SECTOR_Y) = y
                    Enemies_Sector(m,ENEMIES_SECTOR_DAMAGE) = 0
                    Enemies_Sector(m,ENEMIES_SECTOR_SHIELD) = 100
                    Enemies_Sector(m,ENEMIES_SECTOR_PHASERS) = 100
                    Enemies_Sector(m,ENEMIES_SECTOR_TORPEDOES) = 5 - Config_GameLevel
                    Enemies_Sector(m,ENEMIES_SECTOR_PHASERS_COLDDOWN) = 0
                    Enemies_Sector(m,ENEMIES_SECTOR_TORPEDOES_COLDDOWN) = 0
                    RETURN
                END IF
            NEXT m
            RETURN
        END IF
    NEXT n
END SUB
