' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS for Next ----------------------------------------
' ---------------------------------------------------------


' - Includes ----------------------------------------------
#INCLUDE <MemCopy.bas>
#INCLUDE <zx0.bas>


' - LCARS Defines -----------------------------------------
' LCARS work area 44,20-254,182 (210x172)
' left
#DEFINE LCARS_X1 44
' Top
#DEFINE LCARS_Y1 20
' Right
#DEFINE LCARS_X2 254
' Bottom
#DEFINE LCARS_Y2 182
' Right - 8
#DEFINE LCARS_X2_8 246
' Right - 16
#DEFINE LCARS_X2_16 238
' Bottom - 16
#DEFINE LCARS_Y2_16 166
' Middle
#DEFINE LCARS_XM 149
#DEFINE LCARS_YM 101


' - Vars --------------------------------------------------
DIM Opt_Colours(10) AS UByte = _
    { 224,250,122,151,245,201,208,254,146,16,251 }
'    { 224,%11111010,%01101001,%10010111,%11010000,%11001001,%01101100,%11111110,%10010010,16,251 }
'    { 224,%11111010,%10010010,%01101100,%11010000,%11001001,%10010111,%11111110,%01101001,16,251 }
'    { 224,250,15,190,206,213,187,241,15,16,251 }
DIM LCARS_PrintY AS UByte = LCARS_X1
DIM Status_Colours(2) AS UByte = { 224, 248, 16 }


' - Includes ----------------------------------------------
#INCLUDE <retrace.bas>
#INCLUDE <hex.bas>


SUB LCARS_Init()
    border 0
    PAPER 0
    INK 7
    CLS
    
    NextInit()
    
    ' Registers
    NextReg($07,3)        ' 0=3.5Mhz, 1=7Mhz, 2=14Mhz, 3=28 Mhz
    NextReg($08,%01011010)    ' Disable ram contention, enable specdrum, turbosound, beeper
    NextReg($15,%01000101)    ' Sprite and Layer Setup: ClipSprites, S(U+L-5), Sprites not border
    'NextReg($14,231)        ' Transparent color Magenta with bright in ULA
    NextReg($69,%10000000)  'ShowLayer2(1)
    CLS256(0)
    
    BankSwitch67(BANK_LCARS_FONT)
    LoadSD("data/LCARS.nfnt",$c000,$4000,0)
END SUB


SUB LCARS_DrawMain()
    DIM n, y, c, o AS UByte    
    
    LCARS_DrawMenu(0,33,"STATUS",0,Opt_Colours(OPT_STATUS))
    LCARS_DrawMenu(0,42,"DAMAGE",0,Opt_Colours(OPT_DAMAGE))
    LCARS_DrawMenu(0,51,"MAP",0,Opt_Colours(OPT_MAP))
    LCARS_DrawMenu(0,60,"NAV",0,Opt_Colours(OPT_NAV))
    LCARS_DrawMenu(0,69,"TACTIC",0,Opt_Colours(OPT_TACTIC))
    LCARS_DrawMenu(0,78,"OPS",0,Opt_Colours(OPT_OPS))
    LCARS_DrawMenu(0,87,"CTRL",0,Opt_Colours(OPT_CTRL))
    LCARS_DrawMenu(0,96,"HELP",0,Opt_Colours(OPT_HELP))

    LCARS_DrawMenu(0,114,"GREEN",0,Opt_Colours(OPT_GREEN))
    LCARS_DrawMenu(0,123,"RED",0,Opt_Colours(OPT_RED))
    
    c = 52
    o = 1
    y = 33
    FOR n = 0 TO 7
        PrintChar48(34,y,c,o,0,227)
        y = y + 9
        IF o = 7 THEN
            o = 0
            c = c + 1
        ELSE
            o = o + 1
        END IF
    NEXT n
    PrintChar48(34,114,53,1,0,227)
    PrintChar48(34,123,52,0,0,227)
    
    PrintFont88(0,184,"accccdcccccccccccccccccccccccccb",15,0)    
    PrintFont48(2,184,"COMMAND",0,15)
END SUB


SUB LCARS_DrawMenu(x AS UByte, y AS UByte, text AS String, c1 AS UByte, c2 AS UByte)
    PrintFont88(x,y,"    ",c1,c2)
    PrintFont48(x+1,y,text,c1,c2)
    PrintFont88(x+32,y,"o",c2,c1)
END SUB


SUB LCARS_SelectMenu(menu AS UByte)
    DIM c1 AS UByte
    
    c1 = Opt_Colours(menu)
    PrintFont816(0,0,"eccccccccccccccccccccccccccccccb",c1,0)
    PrintFont816(0,16,"ccccm",c1,0)
    PrintFont88(0,105,"cccc",c1,0)  
    PrintFont816(0,132,"cccc",c1,0)
    PrintFont816(0,148,"cccc",c1,0)
    PrintFont816(0,160,"cccc",c1,0)
    PrintFont816(0,167,"iccc",c1,0)
    
    ' Title ends at 248
    IF menu = OPT_RED THEN
        PrintFont816(48,0,"dCOMBAT STATION RED ALERT",c1,0)
    ELSEIF menu = OPT_STATUS THEN
        PrintFont816(192,0,"dSTATUS",c1,0)
    ELSEIF menu = OPT_DAMAGE THEN
        PrintFont816(192,0,"dDAMAGE",c1,0)
    ELSEIF menu = OPT_MAP THEN
        PrintFont816(216,0,"dMAP",c1,0)      
    'ELSEIF menu = OPT_SENSOR THEN
    '    PrintFont816(184,0,"dSENSORS",c1,0)
    ELSEIF menu = OPT_NAV THEN
        PrintFont816(160,0,"dNAVIGATION",c1,0)
    ELSEIF menu = OPT_TACTIC THEN
        PrintFont816(184,0,"dTACTICS",c1,0)
    ELSEIF menu = OPT_OPS THEN
        PrintFont816(160,0,"dOPERATIONS",c1,0)
    'ELSEIF menu = OPT_COMMS THEN
    '    PrintFont816(128,0,"dCOMMUNICATIONS",c1,0)
    ELSEIF menu = OPT_CTRL THEN
        PrintFont816(184,0,"dCONTROL",c1,0)
    ELSEIF menu = OPT_HELP
        PrintFont816(208,0,"dHELP",c1,0)
    END IF        
END SUB


SUB LCARS_Clear()
    DIM n, y, y1, w, pv AS UByte
    DIM dir AS UInteger

    w = LCARS_X2 - LCARS_X1
    pv = GetReg($12) * 2
    BankSwitch67(pv)
    dir = $c000 + (LCARS_Y1 * 256) + LCARS_X1
    FOR y = LCARS_Y1 TO LCARS_Y2
        IF y = 64 THEN
            pv = pv + 2
            BankSwitch67(pv)
            dir = $c000 + LCARS_X1
        ELSEIF y = 128 THEN
            pv = pv + 2
            BankSwitch67(pv)
            dir = $c000 + LCARS_X1
        END IF
               
        POKE(dir,0)
        MemCopy(dir,dir+1,w)
        dir = dir + 256
        
        IF y <> 63 THEN
            IF y <> 127 THEN
                IF y <> LCARS_Y2 THEN
                    POKE(dir,255)
                    MemCopy(dir,dir+1,w)
                END IF
            END IF
        END IF  
        
        FOR n = 0 TO 254
            y1 = n - y1 * 3
        NEXT n
    NEXT y

    POKE(dir,0)
    MemCopy(dir,dir+1,w)
    
    LCARS_PrintY = LCARS_Y1
    
    BankSwitch67(BANK_LCARS_FONT)
    PrintFont88(0,184,"accccdcccccccccccccccccccccccccb",15,0)    
    PrintFont48(4,184,"COMMAND",0,15)
END SUB


' - Clear screen with transparent color -------------------
SUB LCARS_ClearFast(c AS UByte)
    DIM w, pv, x, y AS UByte
    DIM dir AS UInteger
    
    w = LCARS_X2 - LCARS_X1
    pv = GetReg($12) * 2
    BankSwitch67(pv)
    dir = $c000 + (LCARS_Y1 * 256) + LCARS_X1
    FOR y = LCARS_Y1 TO LCARS_Y2
        IF y = 64 THEN
            pv = pv + 2
            BankSwitch67(pv)
            dir = $c000 + LCARS_X1
        ELSEIF y = 128 THEN
            pv = pv + 2
            BankSwitch67(pv)
            dir = $c000 + LCARS_X1
        END IF               
        POKE(dir,c)
        MemCopy(dir,dir+1,w)
        dir = dir + 256
    NEXT y
END SUB


' - Print a text in next line with color c ----------------
SUB LCARS_Print(txt AS String, c AS UByte)
    PrintText816_RTTY(LCARS_X1,LCARS_PrintY,txt,c,0)
    LCARS_PrintY = LCARS_PrintY + 16
END SUB


' - Input -------------------------------------------------
SUB LCARS_Input(maxLength AS UByte)
    DIM n, x, c, l AS UByte
    DIM k AS String

    PrintFont88(0,184,"accccdcccccccccccccccccccccccccb",15,0)    
    PrintFont48(4,184,"COMMAND",0,15)
    
    IF maxLength = 0 OR maxLength = 40 THEN
        maxLength = 40
    END IF
    
    n = 0
    Command = ""
    DO
        PrintFont48(44,184,Command,0,15)
        x = (LEN(Command) * 5) + 44
'PrintFont88(0,8,Command+" ",0,255)
        
        WHILE INKEY$ = ""
            waitretrace
            IF n < 5 THEN
                PrintFont48(x,184,";",0,15)
            ELSEIF n<10 THEN
                PrintFont48(x,184," ",0,15)
            ELSE
                n=0
            END IF
            n=n+1
        WEND        
                
        k = INKEY$
        c = CODE k
        l = LEN(Command)
        PrintFont48(x,184,"  ",0,15)
'PrintFont48(0,0,ToString(c)+" ",0,255)
        IF l = 0 THEN
            IF c = $3F THEN                     ' ?
                Command = k
                RETURN
            ELSEIF c >= $30 AND c <= $39 THEN   ' 0-9
                Command = k
                RETURN
            END IF
        END IF                

        IF c > $60 THEN
            c = c - 32
        ELSEIF c = 12 THEN
            IF l>1 THEN
                Command = Command (TO l - 2)
            ELSE
                Command = ""
            END IF
            c = 0
        ELSEIF c = 13 THEN
            RETURN
        END IF     
        
        IF c > 0 THEN
            Command = Command + CHR$(c)
            IF LEN(Command) >= maxLength THEN
                RETURN
            END IF
        END IF
        WHILE INKEY$ <> "" : WEND       
    LOOP
END SUB


SUB LCARS_Error(txt AS String)
    PrintFont88(0,184,"accccdcccccccccccccccccccccccccb",224,0)    
    PrintFont48(6,184,"ERROR",0,224) 
    PrintFont48(44,184,txt,0,224)
    WaitKey()
END SUB


' - Screen routines ---------------------------------------
SUB LCARS_PushScreen()
    DIM bank1, bank2 AS UByte
    
    bank1 = GetReg($12) * 2
    bank2 = GetReg($13) * 2
    LCARS_BankCopy(bank1,bank2,3)
END SUB


SUB LCARS_PopScreen()
    DIM bank1, bank2 AS UByte
    
    bank1 = GetReg($12) * 2
    bank2 = GetReg($13) * 2
    LCARS_BankCopy(bank2,bank1,3)
END SUB


SUB LCARS_BankCopy(bank1 AS UByte, bank2 AS UByte, numBanks16 AS UByte)
    DIM n, max AS UByte
    
    max = numBanks16 * 2
    FOR n = 0 TO max
        NextRegA($56,bank1)
        NextRegA($57,bank2)
        MemCopy($c000,$e000,$2000)
        bank1 = bank1 + 1
        bank2 = bank2 + 1
    NEXT n
    
    BankSwitch67(BANK_LCARS_FONT)
END SUB


' - PRINT routines ----------------------------------------

SUB LCARS_PrintBlock44(x AS UByte, y AS UByte, s AS UByte)
    DIM sx, sy, xx, yy, spr AS UByte
    
    spr = s
    yy = y
    FOR sy = 0 TO 3
        xx = x
        FOR sx = 0 TO 3
            PrintSprite(xx,yy,spr)
            xx = xx + 16
            spr = spr + 1
        NEXT sx
        yy = yy + 16
    NEXT sy
END SUB


SUB PrintText816_RTTY(x AS UByte, y AS UByte, txt AS String, c1 AS UByte, c2 AS UByte)
    DIM n, l, p AS UByte
    
    IF txt = "" THEN
        RETURN
    END IF
    
    l = LEN(txt) - 1
    FOR n = 0 TO l
        IF INKEY$<>"" THEN
            p = 1
        END IF
        PrintFont816(x,y,txt(n),c1,c2)        
        x = x + 8 
        IF p = 0 THEN
            IF Config_SoundEnabled THEN
                BEEP .005,64
            END IF
            'waitretrace
        END IF
    NEXT n
END SUB


SUB PrintFont816(x AS UByte, y AS UByte, text AS String, c1 AS UByte, c2 AS UByte)
    DIM n, s, o, l, c AS UByte
    
    IF text = "" THEN
        RETURN
    END IF

    l = LEN(text) - 1
    FOR n=0 TO l
        c = CODE text(n)
        IF c>$60 THEN           ' Graphics (lowercase)
            s = c - 53
            o = s MOD 2
            s = s / 2
        ELSEIF c > $40 THEN    ' Letters (uppercase)
            s = c - 64
            o = s MOD 2
            s = s / 2
        ELSEIF c = $3A THEN    ' :
            s = 21
            o = 1
        ELSEIF c = $3B THEN    ' ; (cursor)
            s = 13
            o = 1
        ELSEIF c > $2F THEN    ' Numbers
            s = c - 16
            o = s MOD 2
            s = s / 2
        ELSEIF c = $2B THEN    ' +
            s = 15
            o = 0
        ELSEIF c = $2D THEN    ' -
            s = 15
            o = 1
        ELSEIF c = $2E THEN    ' .
            s = 14
            o = 0
        ELSEIF c = $2C THEN    ' ,
            s = 14
            o = 1
        ELSEIF c = $28 THEN    ' (
            s = 30
            o = 0
        ELSEIF c = $27 THEN    ' '
            s = 31
            o = 1
        ELSEIF c = $29 THEN    ' )
            s = 30
            o = 1
        ELSEIF c = $25 THEN    ' %
            s = 21
            o = 0        
        ELSEIF c = $20 THEN    ' Space
            s = 0
            o = 0
        ELSEIF c = $21 THEN    ' !
            s = 31
            o = 0
        END IF
        PrintChar816(x,y,s,o,c1,c2) 
        x = x + 8
    NEXT n            
END SUB


SUB PrintChar816(x AS UByte, y AS UByte, sprite AS UInteger, offset AS UInteger, c1 AS UByte, c2 AS UByte)
    DIM xx, yy, xp, yp, b, c AS UByte
    DIM dir, spr, d2 AS UInteger
        
    dir = $c000 + (cast(UInteger,sprite) << 8) + (cast(UInteger,offset) << 3)    
    d2 = dir    
    yp = y
    FOR yy = 0 TO 15
        xp = x
        FOR xx = 0 TO 7
            b = PEEK(d2)            
            IF b = 0 THEN
                c = c1
            ELSE
                c = c2
            END IF
            IF c <> 227 THEN
                PlotL2(xp,yp,c)
            END IF
            xp = xp + 1
            d2 = d2 + 1
        NEXT xx
        yp = yp + 1
        dir = dir + 16
        d2 = dir
    NEXT yy            
END SUB


SUB PrintFont88(x AS UByte, y AS UByte, text AS String, c1 AS UByte, c2 AS UByte)
    DIM n, s, o, l, c AS UByte
    
    IF text = "" THEN
        RETURN
    END IF
    
    l = LEN(text) - 1
    FOR n=0 TO l
        c = CODE text(n)
        IF c>$60 THEN           ' Graphics (lowercase)
            s = c + 75
            o = s MOD 4
            s = s / 4
        ELSEIF c > $40 THEN    ' Letters (uppercase)
            s = c + 64
            o = s MOD 4
            s = s / 4
        ELSEIF c = $3A THEN    ' :
            s = 42
            o = 3
        ELSEIF c = $3B THEN    ' ; (cursor)
            s = 46
            o = 0
        ELSEIF c = $3F THEN    ' ?
            s = 46
            o = 3
        ELSEIF c > $2F THEN    ' Numbers
            s = c + 112
            o = s MOD 4
            s = s / 4
        ELSEIF c = $2A THEN    ' *
            s = 38
            o = 3
        ELSEIF c = $2B THEN    ' +
            s = 39
            o = 2
        ELSEIF c = $2D THEN    ' -
            s = 39
            o = 3
        ELSEIF c = $2E THEN    ' .
            s = 39
            o = 0
        ELSEIF c = $2C THEN    ' ,
            s = 39
            o = 1
        ELSEIF c = $25 THEN    ' %
            s = 42
            o = 2       
        ELSEIF c = 32 THEN     ' Space
            s = 32
            o = 0
        END IF
        PrintChar88(x,y,s,o,c1,c2) 
        x = x + 8
    NEXT n            
END SUB


SUB PrintChar88(x AS UByte, y AS UByte, sprite AS UInteger, offset AS UInteger, c1 AS UByte, c2 AS UByte)
    DIM xx, yy, xp, yp, b, c AS UByte
    DIM dir, spr, d2 AS UInteger
    
    dir = $c000 + (cast(UInteger,sprite) << 8)   
    IF offset = 1 THEN
        dir = dir + 128
    ELSEIF offset = 2 THEN
        dir = dir + 8
    ELSEIF offset = 3 THEN
        dir = dir + 136
    END IF
    
    d2 = dir    
    yp = y
    FOR yy = 0 TO 7
        xp = x
        FOR xx = 0 TO 7
            b = PEEK(d2)
            IF b = 0 THEN
                c = c1
            ELSE
                c = c2
            END IF
            PlotL2(xp,yp,c)
            xp = xp + 1
            d2 = d2 + 1
        NEXT xx
        yp = yp + 1
        dir = dir + 16
        d2 = dir
    NEXT yy            
END SUB


SUB PrintChar88_Over(x AS UByte, y AS UByte, sprite AS UInteger, offset AS UInteger, c1 AS UByte)
    DIM xx, yy, xp, yp, b, c AS UByte
    DIM dir, spr, d2 AS UInteger
    
    dir = $c000 + (cast(UInteger,sprite) << 8)   
    IF offset = 1 THEN
        dir = dir + 128
    ELSEIF offset = 2 THEN
        dir = dir + 8
    ELSEIF offset = 3 THEN
        dir = dir + 136
    END IF
    
    d2 = dir    
    yp = y
    FOR yy = 0 TO 7
        xp = x
        FOR xx = 0 TO 7
            b = PEEK(d2)
            IF b = 0 THEN
                PlotL2(xp,yp,c1)
            END IF
            xp = xp + 1
            d2 = d2 + 1
        NEXT xx
        yp = yp + 1
        dir = dir + 16
        d2 = dir
    NEXT yy            
END SUB


SUB PrintFont48(x AS UByte, y AS UByte, text AS String, c1 AS UByte, c2 AS UByte)
    DIM n, s, o, l, c AS UByte
    
    IF LEN(text) = 0 THEN
        RETURN
    END IF
    
    l = LEN(text) - 1
    FOR n=0 TO l
        c = CODE text(n)
        IF c > $40 THEN    ' Letters (uppercase)
            s = c - $41
            o = s MOD 8
            s = (s / 8) + 48
        ELSEIF c = $3A THEN    ' :
            s = 51
            o = 7
        ELSEIF c = $3B THEN    ' ; (cursor)
            s = 51
            o = 2
        ELSEIF c = $3F THEN     ' ?
            s = 53
            o = 6            
        ELSEIF c > $2F THEN    ' Numbers
            s = c - $30
            o = s MOD 8
            s = (s / 8) + 52
        ELSEIF c = $2A THEN    ' *
            s = 53
            o = 5
        ELSEIF c = $2B THEN    ' +
            s = 51
            o = 5
        ELSEIF c = $2D THEN    ' -
            s = 51
            o = 6
        ELSEIF c = $2E THEN    ' .
            s = 51
            o = 3
        ELSEIF c = $2C THEN    ' ,
            s = 51
            o = 4
        ELSEIF c = $25 THEN    ' %
            s = 53
            o = 2       
        ELSEIF c = $20 THEN     ' Space
            s = 53
            o = 4
        ELSEIF c = $28 THEN    ' (
            s = 54
            o = 0
        ELSEIF c = $27 THEN    ' '
            s = 53
            o = 7            
        ELSEIF c = $29 THEN     ' )
            s = 54
            o = 1
        END IF
        PrintChar48(x,y,s,o,c1,c2) 
        x = x + 5
    NEXT n            
END SUB


SUB PrintChar48(x AS UByte, y AS UByte, sprite AS UInteger, offset AS UInteger, c1 AS UByte, c2 AS UByte)
    DIM xx, yy, xp, yp, b, c AS UByte
    DIM dir, spr, d2 AS UInteger
    
    dir = $c000 + (cast(UInteger,sprite) << 8)
    IF offset < 4 THEN
        dir = dir + (offset * 4)
    ELSE
        dir = dir + 128 + ((offset - 4) * 4)
    END IF
    
    d2 = dir    
    yp = y
    FOR yy = 0 TO 7
        xp = x
        FOR xx = 0 TO 3
            b = PEEK(d2)
            IF b = 0 THEN
                c = c1
            ELSE
                c = c2
            END IF
            IF c<>227 THEN
                PlotL2(xp,yp,c)
            END IF
            xp = xp + 1
            d2 = d2 + 1
        NEXT xx
        yp = yp + 1
        dir = dir + 16
        d2 = dir
    NEXT yy            
END SUB


SUB PutSprite4(x AS UByte, y AS UByte, sprite AS UInteger)
    DIM n, x16, y16 AS UByte
    
    n = sprite
    x16 = x + 16
    y16 = y + 16
    PrintSprite(x,y,n)
    n = n + 1
    PrintSprite(x16,y,n)
    n = n + 1
    PrintSprite(x,y16,n)
    n = n + 1
    PrintSprite(x16,y16,n)
END SUB


SUB PrintSprite(x AS UByte, y AS UByte, sprite AS UInteger)
    DIM xx, yy, xp, yp, b AS UByte
    DIM dir, spr, d2 AS UInteger
        
    dir = $c000 + (cast(UInteger,sprite) << 8)    
    d2 = dir   
    yp = y
    FOR yy = 0 TO 15
        xp = x
        FOR xx = 0 TO 15
            b = PEEK(d2)            
            IF b <> 227 THEN
                PlotL2(xp,yp,b)
            END IF
            xp = xp + 1
            d2 = d2 + 1
        NEXT xx
        yp = yp + 1
        dir = dir + 16
        d2 = dir
    NEXT yy            
END SUB


SUB PrintSpriteClour(x AS UByte, y AS UByte, sprite AS UInteger, c AS UByte)
    DIM xx, yy, xp, yp, b AS UByte
    DIM dir, spr, d2 AS UInteger
        
    dir = $c000 + (cast(UInteger,sprite) << 8)    
    d2 = dir   
    yp = y
    FOR yy = 0 TO 15
        xp = x
        FOR xx = 0 TO 15
            b = PEEK(d2)            
            IF b <> 227 THEN
                PlotL2(xp,yp,c)
            END IF
            xp = xp + 1
            d2 = d2 + 1
        NEXT xx
        yp = yp + 1
        dir = dir + 16
        d2 = dir
    NEXT yy            
END SUB


SUB PrintSpriteNoAlpha(x AS UByte, y AS UByte, sprite AS UInteger, c AS UByte = 227)
    DIM xx, yy, xp, yp, b AS UByte
    DIM dir, spr, d2 AS UInteger
        
    dir = $c000 + (cast(UInteger,sprite) << 8)    
    d2 = dir   
    yp = y
    FOR yy = 0 TO 15
        xp = x
        FOR xx = 0 TO 15
            b = PEEK(d2)            
            IF b = 227 THEN
                b = c
            END IF
            PlotL2(xp,yp,b)
            xp = xp + 1
            d2 = d2 + 1
        NEXT xx
        yp = yp + 1
        dir = dir + 16
        d2 = dir
    NEXT yy            
END SUB


SUB LoadImage(file AS String, left AS UByte, top AS UByte, width AS UInteger, height AS UByte)
    DIM fileDir, dirScr, yy, bnk, x, y AS UInteger
    DIM videoBase, bankScr, n AS UByte

    NextRegA($56,BANK_TEMP)
    videoBase = GetReg($12) * 2

    x = left
    y = top
    fileDir = 1024 + 54 + 84 
    FOR n = 1 TO height
        yy = y >> 6
        bankScr = videoBase + (yy*2)
        yy = (y - (yy * 64)) << 8
        dirScr = $c000 + yy + x

        NextRegA($56,bankScr)
        NextRegA($57,bankScr+1) 

        LoadSD(file,dirScr,width,fileDir)
        fileDir = fileDir + width '+ 2
       
        y = y + 1
    NEXT n

    BankSwitch67(BANK_LCARS_FONT)
END SUB


' - Show an image .nbmp from designed bank and address ----
SUB LCARS_ShowImage( _
    left AS UByte, _
    top AS UByte, _
    imageBank AS UByte, _
    imageAddress AS UInteger)
    
    DIM numBlocks, linesBlock AS UByte
    DIM width, height, dirImg, dirIndex AS UInteger
    DIM n, h AS UByte
    DIM x, y AS UInteger
    
    DIM dirMem, dirScr, yy, bnk AS UInteger
    DIM videoBase, bankScr AS UByte

    ' Load header
    NextRegA($56,imageBank)
    dirImg = imageAddress
    numBlocks = PEEK(dirImg)
    dirImg = dirImg + 1
    width = PEEK(UInteger,dirImg)
    dirImg = dirImg + 2
    height = PEEK(UInteger,dirImg)
    dirImg = dirImg + 2
    
    y = top
    x = left        
    NextRegA($57,BANK_TEMP)

    IF numBlocks = 0 THEN
        ' Single block
        dzx0Mega(dirImg,$e000)
        LCARS_ShowImage_DrawBlock(x,y,width,height)
    ELSE
        ' Multiple blocks
        dirIndex = $c005
        FOR n = 1 TO numBlocks        
            NextRegA($56,imageBank)
            ' Number of lines in this block
            h = PEEK(dirIndex)
            ' Address of the pixel data
            dirImg = $c004 + PEEK(UInteger,dirIndex + 1)
            ' Decompress and draw
            dzx0Mega(dirImg,$e000)
            LCARS_ShowImage_DrawBlock(x,y,width,h)
            ' Next block                       
            y = y + h
            dirIndex = dirIndex + 3
        NEXT n
    END IF   
    BankSwitch67(BANK_LCARS_FONT)
END SUB


SUB LCARS_ShowImage_DrawBlock( _
    left AS UInteger, _
    top AS UInteger, _
    width AS UInteger, _
    lines AS UInteger)
    
    DIM n, videoBase, bankScr AS UByte
    DIM x, y, yy, dirMem, dirScr AS UInteger
    
    dirMem = $e000
    videoBase = GetReg($12) * 2

    x = left
    y = top
    FOR n = 1 TO lines
        yy = y >> 6
        bankScr = videoBase + (yy*2)
        yy = (y - (yy * 64)) << 8
        dirScr = $c000 + yy + x

        IF dirScr >= $e000 THEN
            dirScr = dirScr - $2000
            bankScr = bankScr + 1
        END IF
        NextRegA($56,bankScr)

        MemCopy(dirMem,dirScr,width)
        dirMem = dirMem + width
       
        y = y + 1
    NEXT n
END SUB


' - NextLib extensions ------------------------------------

SUB BankSwitch67(b AS UByte)
    NextRegA($56,b)
    NextRegA($57,b+1)
END SUB


SUB L2_LineH(x AS UByte, y AS UByte, w AS UByte, c AS UByte)
    DIM n AS UByte
    
    FOR n = 1 TO w
        PlotL2(x,y,c)
        x = x + 1
    NEXT n
END SUB


SUB L2_LineV(x AS UByte, y AS UByte, h AS UByte, c AS UByte)
    DIM n AS UByte
    
    FOR n = 1 TO h
        PlotL2(x,y,c)
        y = y + 1
    NEXT n
END SUB


SUB L2_Box(byVal x AS Ubyte, byVal y AS UByte, byVal width as UByte, byVal height AS UByte, c AS UByte)
    DIM n, xx, yy AS UByte
        
    xx = x
    yy = y + height
    FOR n = 0 TO width
        PlotL2(xx,y,c)
        PlotL2(xx,yy,c)
        xx = xx + 1
    NEXT n
    
    xx = x + width
    yy = y
    FOR n = 0 TO height
        PlotL2(x,yy,c)
        PlotL2(xx,yy,c)
        yy = yy + 1
    NEXT n    
END SUB
