' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS Video for Next ----------------------------------
' ---------------------------------------------------------


' - NextVideo ---------------------------------------------

SUB LCARS_Video_Play(startBank AS UByte, numFrames AS UByte)
    DIM f, n, bank, pv, pvi AS UByte
    DIM dirData, dirScr AS UInteger

    ' Init vars
    bank = startBank
    pvi = (GetReg($12) * 2) + 1
    dirScr = $e040
    dirData = $c000
    NextRegA($56,BANK_TEMP)

    ' Frames loop
    FOR f = 0 TO numFrames
        ' 128 lines
        FOR n = 0 TO 127
            IF n = 0 THEN
                ' Screen bank +1, Data + 0, lines 0 to 32
                ' Extract data bank
                NextRegA($57,bank)
                dzx0Mega($e000,$c000)
                dirData = $c000
                ' Set video bank
                pv = pvi
                NextRegA($57,pv)
                dirScr = $e040
            ELSEIF n = 32 THEN
                ' Screen bank +1, Data + 0, lines 32 to 48 (scr)
                ' Set video bank
                pv = pv + 1            
                NextRegA($57,pv)
                dirScr = $e040
            ELSEIF n = 48 THEN
                ' Screen bank +1.2, Data + 1, lines 48 to 64 (bank)
                ' Extract data bank
                NextRegA($57,bank)
                dzx0Mega($e800,$c000)
                dirData = $c000
                NextRegA($57,pv)
            ELSEIF n = 64 THEN
                ' Screen bank +1.2, Data + 1, lines 64 to 96 (scr)
                ' Set video bank
                pv = pv + 1            
                NextRegA($57,pv)
                dirScr = $e040
            ELSEIF n = 96 THEN
                ' Screen bank +1.3, Data + 2, lines 96 to 128 (scr + bank)
                ' Extract data bank
                NextRegA($57,bank)
                dzx0Mega($f000,$c000)
                dirData = $c000
                ' Set video bank
                pv = pv + 1 
                NextRegA($57,pv)
                dirScr = $e040
            END IF
    
            MemCopy(dirData,dirScr,170)

            dirData = dirData + 170
            dirScr = dirScr + 256
        NEXT n
        
        bank = bank + 1
        waitretrace
        
        IF INKEY$<>"" THEN
            RETURN
        END IF
    NEXT f
END SUB


' - Play animations ---------------------------------------
SUB LCARS_Video_Play_Warp()
    LCARS_Video_VideoPlaver("EXTERNAL CAM")
    LCARS_Video_Play(BANK_VIDEO_WARP,VIDEO_WARP_FRAMES)
    BankSwitch67(BANK_LCARS_FONT)   
END SUB


SUB LCARS_Video_VideoPlaver(title AS String)
    DIM n AS UByte
    
    PrintFont88(56,24, "ecccccccccccccccccccccc",23,0)
    PrintFont88(56+16,24,title,23,0)
    PrintFont88(234,24,"f",23,0)
    FOR n = 32 TO 157 STEP 8
        PrintFont88(56,n, "c",23,0)
        PrintFont88(234,n,"c",23,0)
    NEXT n
    PrintFont88(56,160,"gcccccccccccccccccccccc",23,0)
    PrintFont88(234,160,"h",23,0)
END SUB


' - Load animations ---------------------------------------
SUB LCARS_Video_LoadAnimation( _
    fileName AS string, _
    startBank AS UByte, _
    numBanks AS UByte)
    DIM bank AS UByte
    DIM offset AS ULong
    
    bank = startBank
    offset = 0
    FOR n = 1 TO numBanks
        NextRegA($56,bank)
        LoadSD(fileName,$c000,$2000,offset)
        offset = offset + $2000
        bank = bank + 1        
    NEXT n
    BankSwitch67(BANK_LCARS_FONT)
END SUB
