' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Main module -------------------------------------------
' ---------------------------------------------------------


' Start calling Main sub
Main()
' Don't exit at exit
DO : LOOP


' - Defines -----------------------------------------------


' - Vars --------------------------------------------------
DIM CommonVars(1024) AS UByte


' - Includes ----------------------------------------------
#INCLUDE <NextLibLite.bas>

#INCLUDE "Common.bas"


' - Main --------------------------------------------------
SUB Main() 
    DIM n AS UByte
    
    ' To Avoid compiler optimization
    n = CommonVars(0)

    EuskalRetro()

    ' Start with module INTRO
    NextModule = MODULE_INTRO
    
    ' Infinite loop
    DO
        ' Run module
        RunModule(NextModule)
    LOOP
END SUB


' - Load a module from SD and run it ----------------------
' Parameters:
'   module (UByte): Module number to load and run
SUB RunModule(module AS UByte)
    DIM fileName AS String
    
    ' Create file name
    fileName="data/mod-" + ToString(module) + ".bin"
    PRINT AT 0,0;"[";fileName;"]";    
    ' Load module
    LoadSD(fileName,$8000,$4000,0)
    ' Run module
    PRINT AT 0,0;USR $8000
END SUB



' - Show Euskal screen ------------------------------------
SUB EuskalRetro()
    DIM pos AS ULong
    DIM bnk, n AS UByte
    
    ' Registers
    NextReg($07,3)          ' 0=3.5Mhz, 1=7Mhz, 2=14Mhz, 3=28 Mhz
    NextReg($08,%01011010)  ' Disable ram contention, enable specdrum, turbosound, beeper
    NextReg($15,%00000101)  ' Sprite and Layer Setup: ClipSprites, S(U+L-5), Sprites not border
    NextReg($69,%10000000)  ' ShowLayer2(1)
    
    pos = 1024+54
    bnk = (GetReg($12) * 2)
    FOR n = 0 TO 5
        NextRegA($56,bnk)
        bnk = bnk + 1
        LoadSD("data/EuskalRetro.bmp",$c000,$2000,pos)
        pos = pos + $2000
    Next n
    WaitKey()
END SUB

