' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Map module (4) ----------------------------------------
' ---------------------------------------------------------
' Parameters:
'   Parameter1: Command:
'                   0: Show map
'                   1: LRSCAN
'                   2: SRSCAN*
'                   3: WARP


' Start calling Map sub
Map()
' Return no Main module
STOP


' - Includes ----------------------------------------------
#INCLUDE "NextLibLite.bas"
#INCLUDE <memcopy.bas>

#INCLUDE <Hex.bas>

#INCLUDE "Common.bas"
#INCLUDE "LCARS_Next.bas"
#INCLUDE "LCARS_Map_Next.bas"
#INCLUDE "LCARS_Video_Next.bas"


' - Map ----------------------------------------------------
SUB Map()
    DIM k AS UByte

    NextModule = MODULE_GAME

    IF Parameter1 = 1 THEN
        LRSCAN()
    ELSEIF Parameter1 = 3 THEN
        Warp()
        Parameter1 = 0
        RETURN
    END IF

    LCARS_SelectMenu(OPT_MAP)
    LCARS_Clear()
    LCARS_Map()
    
    ' Explore actual sector
    LCARS_MAP_CreateSector()    
    
    ' Check sector events
    IF Sector_New = 2
        NextModule = MODULE_REPORT
        Parameter1 = 6
    ELSEIF Sector_Enemies <> 0 THEN
        NextModule = MODULE_REPORT
        Parameter1 = 2
    ELSE
        Parameter1 = 0
    END IF
END SUB


' - Execute LRSCAN command --------------------------------
SUB LRSCAN()
    DIM x, y, minX, maxX, minY, maxY AS Byte
    
    minX = Status_Position_Galaxy_X - 1
    maxX = Status_Position_Galaxy_X + 1
    minY = Status_Position_Galaxy_Y - 1
    maxY = Status_Position_Galaxy_Y + 1
    
    FOR y = minY TO maxY
        FOR x = minX TO maxX
            IF x >= 0 AND x <= MAP_GALAXY_MAXX THEN
                IF y >= 0 AND y <= MAP_GALAXY_MAXY THEN
                    Map_Galaxy(x,y) = Map_Galaxy(x,y) bOR %1
                END IF
            END IF
        NEXT x
    NEXT y
    
    Status_Energy = Status_Energy - 100
END SUB


' - Warp command ------------------------------------------
SUB Warp()
    DIM n AS UByte
    DIM speed, coordX, coordY AS Integer
    DIM h, e AS Integer
    DIM mode AS String
    
    GetCommandAndWords()
    mode = Command_Words(1)
    speed = ToNumber(Command_Words(2))
    coordX = ToNumber(Command_Words(3))
    coordY = ToNumber(Command_Words(4))

    ' Check syntax
    IF mode <> "A" AND mode <> "M" THEN
        WarpError(0)
        RETURN
    ELSEIF speed = $FF OR coordX = $FF OR coordY = $FF THEN
        WarpError(0)
        RETURN
    END IF
    
    ' Check spped
    IF speed < 1 OR speed >10 THEN
        WarpError(1)        
        RETURN
    END IF
    
    IF mode = "A" THEN
        ' Check coordX and CoordY pameter
        IF coordX < 1 OR coordX > MAP_GALAXY_MAXX OR coordY < 1 OR coordY > MAP_GALAXY_MAXY THEN
            WarpError(2)
            RETURN
        END IF
        ' Calc distance and energy    
        h = ABS(Status_Position_Galaxy_X-(coordX-1)) + ABS(Status_Position_Galaxy_Y-(coordY-1))
    ELSEIF mode = "M" THEN
        ' Check coordX and CoordY pameter
        IF coordX < -10 OR coordX > 10 OR coordY < -10 OR coordY > 10 THEN
            WarpError(3)
            RETURN
        END IF
        ' Calc distance and energy    
        h = ABS(coordX) + ABS(coordY)
    END IF
    
    ' Calc StarDate
    AddDate(h)   
    ' Energy
    e = Status_Energy - (h * 10 * speed)
    IF e < 0 THEN
        NextModule = MODULE_REPORT
        Parameter1 = 4
        RETURN
    END IF
    Status_Energy = e
    
    ' Move
    IF mode = "A" THEN
        Status_Energy = Status_Energy - 100
        Status_Position_Galaxy_X = coordX - 1
        Status_Position_Galaxy_Y = coordY - 1    
    ELSE
        Status_Position_Galaxy_X = Status_Position_Galaxy_X + coordX
        Status_Position_Galaxy_Y = Status_Position_Galaxy_Y + coordY
    END IF
    
    IF Status_Position_Galaxy_X < 0 THEN
        Status_Position_Galaxy_X = 0
    ELSEIF Status_Position_Galaxy_X > MAP_GALAXY_MAXX THEN
        Status_Position_Galaxy_X = MAP_GALAXY_MAXX
    END IF
    IF Status_Position_Galaxy_Y < 0 THEN
        Status_Position_Galaxy_Y = 0
    ELSEIF Status_Position_Galaxy_Y > MAP_GALAXY_MAXY THEN
        Status_Position_Galaxy_Y = MAP_GALAXY_MAXY
    END IF
    
    LCARS_Video_Play_Warp()

    NextModule = MODULE_NAV    
END SUB


SUB WarpError(err AS UByte)
    IF err = 0 THEN
        LCARS_Error("INVALID PARAMETER, CHECK: HELP WARP")   
    ELSEIF err = 1 THEN
        LCARS_Error("WARP SPEED MUST BE IN THE RANGE OF 1 TO 10")
    ELSEIF err = 2 THEN
        LCARS_Error("INVALID COORDINATES, CHECK: HELP WARP")
    ELSEIF err = 3 THEN
        LCARS_Error("THE MAXIMUM DISPLACEMENT IS 10")
    END IF
END SUB
