
xqaq' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Nav module (6) ----------------------------------------
' ---------------------------------------------------------
' Parameters:
'   Parameter1: Command:
'                   0: Show sector map
'                   1: IMPULSE
'                   2: PHASERS


' Start calling Nav sub
Nav()
' Return no Main module
STOP


' - Includes ----------------------------------------------
#INCLUDE "NextLibLite.bas"
#INCLUDE <memcopy.bas>

#INCLUDE "Common.bas"
#INCLUDE "LCARS_Next.bas"
#INCLUDE "LCARS_Map_Next.bas"
#INCLUDE "LCARS_Nav_Next.bas"


' - Map ----------------------------------------------------
SUB Nav()
    DIM n AS UByte    

    ' Init
    NextModule = MODULE_GAME
    IF Status_Condition = 2 THEN
        LCARS_Combat_DrawMenu()
    ELSE
        LCARS_SelectMenu(OPT_NAV)
    END IF
    LCARS_Clear()
    
    IF Parameter1 = 1 THEN
        Impulse()
    END IF   
    
    ' Create new sector if not scanned
    LCARS_MAP_CreateSector()
    
    IF Sector_New = 2 THEN
        NextModule = MODULE_REPORT
        Parameter1 = 6
        RETURN
    END IF
    
    ' Draw grid
    LCARS_Nav_DrawGrid()
    
    ' Report?    
    IF Sector_New = 1 THEN
        IF Sector_Enemies > 0 THEN
            NextModule = MODULE_REPORT
            Parameter1 = 2
        ELSEIF Sector_StarBases > 0 THEN
            NextModule = MODULE_REPORT
            Parameter1 = 3
         ELSEIF Sector_Planets_Dilitrium > 0 THEN
            IF Status_Energy < 2500 THEN
                NextModule = MODULE_REPORT
                Parameter1 = 4
            END IF
        END IF
    END IF
END SUB


' - Impulse command ---------------------------------------
SUB Impulse()
    DIM n AS UByte
    DIM speed, coordX, coordY AS Integer
    DIM h, e AS Integer
    DIM mode AS String
    
    GetCommandAndWords()
    mode = Command_Words(1)
    coordX = ToNumber(Command_Words(2))
    coordY = ToNumber(Command_Words(3))

    ' Check syntax
    IF mode <> "A" AND mode <> "M" THEN
        ImpulseError(0)
        RETURN
    END IF

    IF mode = "A" THEN
        ' Check coordX and CoordY pameter
        IF coordX < 1 OR coordX > MAP_SECTOR_MAXX OR coordY < 1 OR coordY > MAP_SECTOR_MAXY THEN
            ImpulseError(2)
            RETURN
        END IF
        ' Calc distance and energy    
        h = ABS(Status_Position_Sector_X-(coordX-1)) + ABS(Status_Position_Sector_Y-(coordY-1))
    ELSEIF mode = "M" THEN
        ' Check coordX and CoordY pameter
        IF coordX < -10 OR coordX > 10 OR coordY < -10 OR coordY > 10 THEN
            ImpulseError(3)
            RETURN
        END IF
        ' Calc distance and energy    
        h = ABS(coordX) + ABS(coordY)
    END IF
    
    ' Calc StarDate
    AddDate(h)   
    ' Energy
    e = Status_Energy - (h * 9)
    IF e < 0 THEN
        NextModule = MODULE_REPORT
        Parameter1 = 4
        RETURN
    END IF
    Status_Energy = e
    
    ' Move
    IF mode = "A" THEN
        Status_Energy = Status_Energy - 100
        Status_Position_Sector_X = coordX
        Status_Position_Sector_Y = coordY    
    ELSE
        Status_Position_Sector_X = Status_Position_Sector_X + coordX
        Status_Position_Sector_Y = Status_Position_Sector_Y + coordY
    END IF
    
    IF Status_Position_Sector_X < 0 THEN
        Status_Position_Sector_X = 0
    ELSEIF Status_Position_Sector_X > MAP_SECTOR_MAXX THEN
        Status_Position_Sector_X = MAP_SECTOR_MAXX
    END IF
    IF Status_Position_Sector_Y < 0 THEN
        Status_Position_Sector_Y = 0
    ELSEIF Status_Position_Sector_Y > MAP_SECTOR_MAXY THEN
        Status_Position_Sector_Y = MAP_SECTOR_MAXY
    END IF   
END SUB


SUB ImpulseError(err AS UByte)
    IF err = 0 THEN
        LCARS_Error("INVALID PARAMETER, CHECK: HELP IMPULSE")   
    ELSEIF err = 2 THEN
        LCARS_Error("INVALID COORDINATES, CHECK: HELP IMPULSE")
    ELSEIF err = 3 THEN
        LCARS_Error("THE MAXIMUM DISPLACEMENT IS 10")
    END IF
END SUB

