' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - Report module (7) -------------------------------------
' ---------------------------------------------------------
' Parameters:
'   Parameter1: 0: Execute Command_Words(1)
'               1: First execution (show Riker tip)
'               2: Enemies in sector (Worf)
'               3: Starbase in sector (Data)
'               4: Planet with dilitrium (Geordi)
'               5: No energy (Geordi)
'               6: Game Over (SuperNova)
'               7: Game Over (Destroyed by enemy)


' Start calling Report sub
Report()
' Return no Main module
STOP


' - Vars --------------------------------------------------
DIM Messages(5) AS String


' - Includes ----------------------------------------------
#INCLUDE "NextLibLite.bas"

#INCLUDE "Common.bas"
#INCLUDE "LCARS_Next.bas"
#INCLUDE "LCARS_Report_Next.bas"


' - Report ------------------------------------------------
SUB Report()
    DIM n, npc AS UByte

    BankSwitch67(BANK_LCARS_FONT)
    IF Parameter1 = 1 THEN
        ' First execution (show Riker tip)
        RESTORE TIPS_FIRST_EXECUTION
    ELSEIF Parameter1 = 2 THEN
        RESTORE TIPS_ENEMIES_IN_SECTOR
    ELSEIF Parameter1 = 3 THEN 
        RESTORE TIPS_STARBASE_IN_SECTOR
    ELSEIF Parameter1 = 4 THEN   
        RESTORE TIPS_DILITRIUM_IN_SECTOR
    ELSEIF Parameter1 = 5 THEN   
        RESTORE TIPS_ENERGY_LOW
    ELSEIF Parameter1 = 6 THEN
        GameOver_SuperNova()
        NextModule = MODULE_INTRO        
        RETURN
    ELSEIF Parameter1 = 7
        GameOver_Destroyed()
        NextModule = MODULE_INTRO        
        RETURN
    END IF

    ReadMessages()
            
    NextModule = MODULE_GAME
    Parameter1 = 0
END SUB


SUB ReadMessages()
    DIM n, npc AS UByte
    DIM name, t AS String
    
    READ npc
    READ name
    FOR n = 0 TO 5    
        READ t
        Messages(n) = t
        IF t = "#" THEN
            EXIT FOR
        END IF
    NEXT n
    
    LCARS_Report_Tip(npc,name)
END SUB


SUB GameOver_SuperNova()
    DIM y AS UByte
    
    BankSwitch67(BANK_TEMP)
    LoadImage("data/SuperNova.bmp",0,0,256,192)

    y = 0
    PrintText816_RTTY(0,y,"GAME OVER",224,227)
    y = 128+16    
    PrintText816_RTTY(0,y,"YOU HAVE ENTERED A SECTOR",15,227)
    y = y + 16 
    PrintText816_RTTY(0,y,"WITH A SUPERNOVA AND HAVE",15,227)
    y = y + 16
    PrintText816_RTTY(0,y,"BEEN DESTROYED.",15,227)

    WaitKey()
END SUB


SUB GameOver_Destroyed()
    DIM y AS UByte
    
    BankSwitch67(BANK_TEMP)
    LoadImage("data/EntExplosion.bmp",0,0,256,192)

    y = 0
    PrintText816_RTTY(2,y,"GAME OVER",224,227)
    y = 128    
    PrintText816_RTTY(2,y,"THE ENTERPRISE, THE FLAGSHIP",252,227)
    y = y + 16 
    PrintText816_RTTY(2,y,"OF THE FEDERATION, HAS BEEN",252,227)
    y = y + 16
    PrintText816_RTTY(2,y,"DESTROYED, AND WITH IT, THE",252,227)
    y = y + 16
    PrintText816_RTTY(2,y,"LAST HOPE OF THE FEDERATION.",252,227)
    WaitKey()
END SUB



TIPS_FIRST_EXECUTION:
     '123456789012345678901234567890
DATA NPC_RIKER
DATA "RIKER - NUMBER ONE"
DATA "CAPTAIN, WE DO NOT KNOW WHERE"
DATA "THE ROMULANS ARE."
DATA "SO I RECOMMEND A THOROUGH"
DATA "SWEEP OF SECTORS WITH THE"
DATA "LONG-RANGE SCANNER."
DATA "#"

TIPS_ENEMIES_IN_SECTOR:
     '123456789012345678901234567890
DATA NPC_WORF
DATA "LIEUTENANT WORF"
DATA "CAPTAIN, I DETECT ONE OR MORE"
DATA "HOSTILE SHIPS IN THIS SECTOR."
DATA "I RECOMMEND RED ALERT AND ARM"
DATA "TORPEDOS AND PHASERS FOR"
DATA "COMBAT."
DATA "#"

TIPS_STARBASE_IN_SECTOR:
     '123456789012345678901234567890
DATA NPC_DATA
DATA "LT. COMMANDER DATA"
DATA "CAPTAIN, THERE IS A STARBASE"
DATA "NEARBY. WE COULD DOCK THERE TO"
DATA "REFUEL DILITHIUM AND ARMAMENT,"
DATA "AS WELL AS MAKE SOME REPAIRS."
DATA "#"

TIPS_DILITRIUM_IN_SECTOR:
     '123456789012345678901234567890
DATA NPC_GEORDI
DATA "LIEUTENANT GEORDI"
DATA "CAPTAIN, WE ARE LOW ON POWER"
DATA "AND THERE IS A DILITHIUM"
DATA "PLANET IN THIS SECTOR."
DATA "WE COULD MINE SOME TO"
DATA "INCREASE OUR ENERGY LEVEL."
DATA "#"

TIPS_ENERGY_LOW:
     '123456789012345678901234567890
DATA NPC_GEORDI
DATA "LIEUTENANT GEORDI"
DATA "CAPTAIN, WE DO NOT HAVE ENOUGH"
DATA "POWER TO PERFORM THAT ACTION."
DATA "WE COULD TRY TO TRANSFER POWER"
DATA "FROM OTHER SYSTEMS."
DATA "#"
